//CRC32    JOB (SYS),'INSTALL CRC32',                                   00000100
//             CLASS=S,MSGCLASS=X                                       00000200
//*                                                                     00000300
//* Source: Xephon article, January 1996 (no author attribution)        00000400
//* Target: SYS2.CMDLIB   SYS2.HELP                                     00000500
//*                                                                     00000600
//********************************************************************* 00000700
//* This JOB installs CRC32 (calculate CRC32 sum on MVS dataset).     * 00000800
//********************************************************************* 00000900
//*                                                                     00001000
//INSTALL PROC SOUT='*',               <=== SYSOUT CLASS                00001100
//             LIB='SYS2.CMDLIB',      <=== TARGET LOAD LIBRARY         00001200
//             HELP='SYS2.HELP',       <=== HELP LIBRARY                00001300
//             SYSTS=SYSDA,            <=== UNITNAME FOR WORK DATASETS  00001400
//             ASMBLR=IFOX00,          <=== NAME OF YOUR ASSEMBLER      00001500
//             ALIB='SYSC.LINKLIB',    <=== LOCATION OF YOUR ASSEMBLER  00001600
//             MACLIB='SYS1.MACLIB',   <=== MACLIB DATASET NAME         00001700
//             AMODGEN='SYS1.AMODGEN'  <=== AMODGEN DATASET NAME        00001800
//*                                                                     00001900
//IEBUPDTE EXEC PGM=IEBUPDTE,PARM=NEW                                   00002000
//SYSPRINT DD  SYSOUT=&SOUT                                             00002100
//SYSUT1   DD  DSN=&HELP,DISP=SHR                                       00002200
//SYSUT2   DD  DSN=&HELP,DISP=SHR                                       00002300
//*                                                                     00002400
//ASM     EXEC PGM=&ASMBLR,REGION=2048K,                                00002500
//             PARM='LIST,NOLOAD,DECK,XREF(SHORT)'                      00002600
//STEPLIB  DD  DSN=&ALIB,DISP=SHR                                       00002700
//SYSTERM  DD  SYSOUT=&SOUT                                             00002800
//SYSPRINT DD  SYSOUT=&SOUT                                             00002900
//SYSLIB   DD  DSN=&MACLIB,DISP=SHR                                     00003000
//         DD  DSN=&AMODGEN,DISP=SHR                                    00003100
//SYSUT1   DD  UNIT=&SYSTS,SPACE=(TRK,(30,15))                          00003200
//SYSUT2   DD  UNIT=&SYSTS,SPACE=(TRK,(30,15))                          00003300
//SYSUT3   DD  UNIT=&SYSTS,SPACE=(TRK,(30,15))                          00003400
//SYSPUNCH DD  DSN=&&SYSLIN,UNIT=&SYSTS,DISP=(,PASS,DELETE),            00003500
//             SPACE=(TRK,(10,1),RLSE),                                 00003600
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=800)                      00003700
//*                                                                     00003800
//LKED    EXEC PGM=IEWL,COND=(0,NE),PARM='LIST,MAP,XREF'                00003900
//SYSPRINT DD  SYSOUT=&SOUT                                             00004000
//SYSUT1   DD  UNIT=&SYSTS,SPACE=(TRK,10)                               00004100
//SYSLMOD  DD  DSN=&LIB,DISP=SHR                                        00004200
//SYSLIN   DD  DSN=&&SYSLIN,DISP=(OLD,DELETE)                           00004300
//         DD  DDNAME=SYSIN                                             00004400
//        PEND                                                          00004500
//*                                                                     00004600
//        EXEC INSTALL                                                  00004700
//*                                                                     00004800
//IEBUPDTE.SYSIN DD *                                                   00004900
./ ADD NAME=CRC32                                                       00005000
./ NUMBER NEW1=10,INCR=10                                               00005100
)F FUNCTION -                                                           00005200
  The CRC32 command is used to compute a Cyclic Redundancy Check (CRC)  00005300
  value for any non-VSAM dataset.  This value is used to verify the     00005400
  successful transfer of files between computers as well as to check for00005500
  file modification by comparison with a previously computed CRC value. 00005600
  The CRC value ensures with over 99% probability (but not 100%) that   00005700
  files have transferred correctly or have not been modified.  The user 00005800
  should have an equivalent program to compute the CRC value on the     00005900
  non-MVS system.                                                       00006000
                                                                        00006100
)X SYNTAX  -                                                            00006200
   CRC32 'dsname'                                                       00006300
         VOLSER(volume)                                                 00006400
   Required - dsname                                                    00006500
)O OPERANDS -                                                           00006600
  'dsname' - The dataset name (with optional member name for partitioned00006700
             datasets) for which a CRC value is to be computed. The     00006800
             naming follows standard TSO conventions.  The dataset may  00006900
             be any non-VSAM dataset and have any record format, logical00007000
             record length, and blocksize.                              00007100
))VOLSER(volume) - the volume on which the dataset resides: required if 00007200
                   the dataset is not catalogued, optional otherwise.   00007300
./ ENDUP                                                                00007400
//*----------------------------------------------------------- IEBUPDTE 00007500
//*                                                                     00007600
//ASM.SYSIN DD *                                                        00007700
         MACRO                                                          00007800
         YREGS                                                          00007900
         GBLA  &REGS                                                    00008000
&REGS    SETA  1                                                        00008100
         SPACE 1                                                        00008200
R0       EQU   0                                                        00008300
R1       EQU   1                                                        00008400
R2       EQU   2                                                        00008500
R3       EQU   3                                                        00008600
R4       EQU   4                                                        00008700
R5       EQU   5                                                        00008800
R6       EQU   6                                                        00008900
R7       EQU   7                                                        00009000
R8       EQU   8                                                        00009100
R9       EQU   9                                                        00009200
R10      EQU   10                                                       00009300
R11      EQU   11                                                       00009400
R12      EQU   12                                                       00009500
R13      EQU   13                                                       00009600
R14      EQU   14                                                       00009700
R15      EQU   15                                                       00009800
         SPACE 1                                                        00009900
         MEND                                                           00010000
*                                                                       00010100
*        %GOTO DECBL1;      /*                                          00010200
         MACRO                                                          00010300
         IHADECB &DSECT=YES                                             00010400
         AIF   ('&DSECT' EQ 'NO').NODSCT                                00010500
DECB     DSECT , -            DECBPTR                                   00010600
         AGO   .CONT                                                    00010700
.NODSCT  ANOP                                                           00010800
         DS    0D                                                       00010900
DECB     EQU   * -            DECBPTR                                   00011000
.CONT    ANOP  ,  */                                                    00011100
*%DECBL1 : ;                                                            00011200
*                                                                       00011300
*/* **************************************************************** */ 00011400
*/*            DATA EVENT CONTROL BLOCKS FOR -                       */ 00011500
*/*            BSAM, BISAM, BDAM, QTAM, BTAM                         */ 00011600
*/*                                                                  */ 00011700
*/*  OS/VS2 RELEASE 3, OS/VS1 RELEASE 4, 08/30/74, LEVEL=1           */ 00011800
*/*                                                                  */ 00011900
*/*  METHOD OF ACCESS                                                */ 00012000
*/*      BAL  - DSECT IS PRODUCED UNLESS DSECT=NO IS SPECIFIED.      */ 00012100
*/*             USING ON DECB GIVES ADDRESSABILITY FOR ALL SYMBOLS.  */ 00012200
*/*      PL/S - DCL DECBPT PTR                                       */ 00012300
*/* **************************************************************** */ 00012400
*%GOTO DECBL2;  /*                                                      00012500
         SPACE 1                                                        00012600
         IEZBITS , -          SYMBOLIC BIT DEFINITIONS                  00012700
         SPACE 1                                                        00012800
*********************************************************************** 00012900
*              DATA EVENT CONTROL BLOCK FOR BSAM                      * 00013000
*********************************************************************** 00013100
         SPACE 1                                                        00013200
DECSDECB DS    CL4 -          EVENT CONTROL BLOCK                       00013300
DECBPTR  DS    0A -           FOR IBM 1419 MAGNETIC CHARACTER READER    00013400
*                             AND IBM 1275 OPTICAL READER SORTER, A     00013500
*                             POINTER TO NEXT DECB TO BE TESTED FOR     00013600
*                             COMPLETION BY THE CHECK MACRO             00013700
*                             INSTRUCTION.  (DECB CHAINING APPLIES TO   00013800
*                             THE USE OF MORE THAN ONE DEVICE.)  THIS   00013900
*                             FIELD IN THE LAST DECB MUST BE ZERO.      00014000
DECTYPE  DS    0BL2 -         TYPE OF I/O REQUEST                       00014100
DECTYPE1 DS    B -            TYPE OF LENGTH OPERAND                    00014200
DECLNS   EQU   BIT0 -         S CODED FOR LENGTH                        00014300
DECRSV01 EQU   BIT1,,C'X' -   RESERVED                                  00014400
DECRSV02 EQU   BIT2,,C'X' -   RESERVED                                  00014500
DECRSV03 EQU   BIT3,,C'X' -   RESERVED                                  00014600
DECRSV04 EQU   BIT4,,C'X' -   RESERVED                                  00014700
DECRSV05 EQU   BIT5,,C'X' -   RESERVED                                  00014800
DECRSV06 EQU   BIT6,,C'X' -   RESERVED                                  00014900
DECRSV07 EQU   BIT7,,C'X' -   RESERVED                                  00015000
DECTYPE2 DS    B -            TYPE OF OPERATION                         00015100
DECRDSF  EQU   BIT0 -         READ SF                                   00015200
DECRDSB  EQU   BIT1 -         READ SB                                   00015300
DECWRSF  EQU   BIT2 -         WRITE SF                                  00015400
DECWRSD  EQU   BIT3 -         WRITE SD                                  00015500
DECRSV08 EQU   BIT4,,C'X' -   RESERVED                                  00015600
DECWRSZ  EQU   BIT5 -         WRITE SZ                                  00015700
DECRSV09 EQU   BIT6,,C'X' -   RESERVED                                  00015800
DECWRSFR EQU   BIT7 -         WRITE SFR (BIT 2 IS ALSO ON) OR           00015900
*                             READ RBL (BIT 0 IS ALSO ON)        MDC004 00016000
DECLNGTH DS    H -            LENGTH OF KEY AND DATA                    00016100
DECDCBAD DS    A -            ADDRESS OF THE DCB TO WHICH THIS I/O      00016200
*                             REQUEST IS RELATED                        00016300
DECAREA  DS    A -            ADDRESS OF KEY AND DATA, OR FOR 1287 OR   00016400
*                             1288 OPTICAL READERS, THE ADDRESS OF A    00016500
*                             USER-SPECIFIED CHANNEL PROGRAM            00016600
DECIOBPT DS    A -            ADDRESS OF THE IOB                        00016700
DECNEXT  DS    0A -           SAME AS DECNEXTA BELOW                    00016800
DECRSV10 DS    X -            RESERVED                                  00016900
DECNEXTA DS    AL3 -          ADDRESS OF THE NEXT ADDRESS FEEDBACK      00017000
*                             FIELD.  PRESENT ONLY IF R IS CODED IN     00017100
*                             THE WRITE MACRO.                          00017200
         SPACE 2                                                        00017300
         ORG   DECNEXT -      FOR 3886 ONLY, DEVICE DEPENDENT FIELDS    00017400
DECBHDRA DS    A -            FOR READ RBL, ADDRESS OF 3886 DATA        00017500
*                             HEADER RECORD AFTER READ           MDC001 00017600
DECBLNNM DS    A -            FOR READ RBL, ADDRESS OF LINE NUMBER OR   00017700
*                             NEGATIVE OF LINE NUMBER            MDC002 00017800
DECBLFMT DS    A -            FOR READ RBL, ADDRESS OF LINE FORMAT      00017900
*                             NUMBER OR NEGATIVE OF LINE FORMAT         00018000
*                             NUMBER                             MDC003 00018100
         SPACE 2                                                        00018200
*********************************************************************** 00018300
*              DATA EVENT CONTROL BLOCK FOR BISAM                     * 00018400
*********************************************************************** 00018500
         SPACE 1                                                        00018600
         ORG   DECB                                                     00018700
DECBECB  DS    0CL4 -         EVENT CONTROL BLOCK                       00018800
DECBRB   DS    0A -           SAME AS DECBRBA BELOW                     00018900
DECBECBF DS    B -            FLAG FIELD                                00019000
DECBWAIT EQU   BIT0 -         AWAITING COMPLETION OF EVENT              00019100
DECBPOST EQU   BIT1 -         EVENT HAS COMPLETED NORMALLY OR           00019200
*                             ABNORMALLY.  IF THE EVENT COMPLETED       00019300
*                             ABNORMALLY, FIELDS DECBEXC1 AND DECBEXC2  00019400
*                             WILL SHOW THE REASON.                     00019500
DECRSV11 EQU   BIT2,,C'X' -   RESERVED                                  00019600
DECRSV12 EQU   BIT3,,C'X' -   RESERVED                                  00019700
DECRSV13 EQU   BIT4,,C'X' -   RESERVED                                  00019800
DECRSV14 EQU   BIT5,,C'X' -   RESERVED                                  00019900
DECRSV15 EQU   BIT6,,C'X' -   RESERVED                                  00020000
DECRSV16 EQU   BIT7,,C'X' -   RESERVED                                  00020100
DECBRBA  DS    AL3 -          ADDRESS OF THE RB FOR THE PROGRAM         00020200
*                             AWAITING EVENT (BEFORE EVENT COMPLETION)  00020300
*                             OR RESERVED (AFTER EVENT COMPLETION)      00020400
DECBTYP1 DS    B -            OPTION BYTE                               00020500
DECRSV17 EQU   BIT0,,C'X' -   RESERVED                                  00020600
DECRSV18 EQU   BIT1,,C'X' -   RESERVED                                  00020700
DECRSV19 EQU   BIT2,,C'X' -   RESERVED                                  00020800
DECRSV20 EQU   BIT3,,C'X' -   RESERVED                                  00020900
DECRSV21 EQU   BIT4,,C'X' -   RESERVED                                  00021000
DECRSV22 EQU   BIT5,,C'X' -   RESERVED                                  00021100
DECBLNS  EQU   BIT6 -         LENGTH CODED AS 'S'                       00021200
DECBARS  EQU   BIT7 -         AREA CODED AS 'S'                         00021300
DECBTYP2 DS    B -            TYPE OF I/O REQUEST                       00021400
DECBRDK  EQU   BIT0 -         READ K                                    00021500
DECRSV23 EQU   BIT1,,C'X' -   RESERVED                                  00021600
DECBRDKU EQU   BIT2 -         READ KU                                   00021700
DECRSV24 EQU   BIT3,,C'X' -   RESERVED                                  00021800
DECBWRK  EQU   BIT4 -         WRITE K                                   00021900
DECBWRKN EQU   BIT5 -         WRITE KN                                  00022000
DECRSV25 EQU   BIT6,,C'X' -   RESERVED                                  00022100
DECRSV26 EQU   BIT7,,C'X' -   RESERVED                                  00022200
DECBLGTH DS    H -            NUMBER OF BYTES READ OR WRITTEN           00022300
DECBDCBA DS    A -            ADDRESS OF THE DATA CONTROL BLOCK         00022400
DECBAREA DS    A -            ADDRESS OF THE AREA IN STORAGE FOR THE    00022500
*                             RECORD                                    00022600
DECBLOGR DS    A -            ADDRESS OF THE LOGICAL RECORD             00022700
DECBKEY  DS    A -            ADDRESS OF THE KEY PORTION OF THE RECORD  00022800
DECBEXC1 DS    B -            EXCEPTIONAL CONDITION CODE BYTE 1         00022900
DECEXRNF EQU   BIT0 -         RECORD NOT FOUND                          00023000
DECEXRLC EQU   BIT1 -         RECORD LENGTH CHECK                       00023100
DECEXNSP EQU   BIT2 -         SPACE NOT FOUND IN WHICH TO ADD A RECORD  00023200
DECEXINV EQU   BIT3 -         INVALID REQUEST                           00023300
DECEXERR EQU   BIT4 -         UNCORRECTABLE I/O ERROR                   00023400
DECEXUBK EQU   BIT5 -         UNREACHABLE BLOCK                         00023500
DECEXOFL EQU   BIT6 -         OVERFLOW RECORD                           00023600
DECEXDUP EQU   BIT7 -         DUPLICATE RECORD PRESENTED FOR INCLUSION  00023700
*                             IN THE DATA SET                           00023800
DECBEXC2 DS    B -            EXCEPTIONAL CONDITION CODE BYTE 2         00023900
DECRSV27 EQU   BIT0,,C'X' -   RESERVED                                  00024000
DECRSV28 EQU   BIT1,,C'X' -   RESERVED                                  00024100
DECRSV29 EQU   BIT2,,C'X' -   RESERVED                                  00024200
DECRSV30 EQU   BIT3,,C'X' -   RESERVED                                  00024300
DECRSV31 EQU   BIT4,,C'X' -   RESERVED                                  00024400
DECRSV32 EQU   BIT5,,C'X' -   RESERVED                                  00024500
DECEXASR EQU   BIT6 -         EXECUTION OF THE LAST CHANNEL PROGRAM WAS 00024600
*                             INSTITUTED BY AN ASYNCHRONOUS ROUTINE     00024700
DECEXRKU EQU   BIT7 -         PREVIOUS MACRO INSTRUCTION WAS READ KU    00024800
         SPACE 2                                                        00024900
*********************************************************************** 00025000
*              DATA EVENT CONTROL BLOCK FOR BDAM                      * 00025100
*********************************************************************** 00025200
         SPACE 1                                                        00025300
         ORG   DECB                                                     00025400
         DS    0CL4 -         DECSDECB - EVENT CONTROL BLOCK            00025500
         DS    B -            COMPLETION CODE BYTE 1                    00025600
DECCC2   DS    B -            COMPLETION CODE BYTE 2                    00025700
DECCCRNF EQU   BIT0 -         RECORD NOT FOUND                          00025800
DECCCRLC EQU   BIT1 -         RECORD LENGTH CHECK                       00025900
DECCCNSP EQU   BIT2 -         SPACE NOT FOUND                           00026000
DECCCINV EQU   BIT3 -         INVALID REQUEST.  (THIS CONDITION ALSO    00026100
*                             SETS A BIT IN THE NEXT BYTE.)             00026200
DECCCERR EQU   BIT4 -         UNCORRECTABLE I/O ERROR                   00026300
DECCCEOD EQU   BIT5 -         END OF DATA                               00026400
DECCCUER EQU   BIT6 -         UNCORRECTABLE ERROR OTHER THAN AN I/O     00026500
*                             ERROR                                     00026600
DECCCREX EQU   BIT7 -         A WRITE WITH EXCLUSIVE CONTROL WAS NOT    00026700
*                             PRECEDED BY A READ WITH EXCLUSIVE CONTROL 00026800
*                             (MDC300)                         @Z30AQ9A 00026900
DECCC3   DS    B -            COMPLETION CODE BYTE 3                    00027000
DECRSV33 EQU   BIT0,,C'X' -   RESERVED                                  00027100
DECCCWRI EQU   BIT1 -         A WRITE MACRO INSTRUCTION WAS ADDRESSED   00027200
*                             TO AN INPUT DATA SET                      00027300
DECCCEXS EQU   BIT2 -         AN EXTENDED SEARCH WAS SPECIFIED WITH THE 00027400
*                             DCBLIMCT FIELD SET TO ZERO                00027500
DECCCNBK EQU   BIT3 -         THE BLOCK REQUESTED IS NOT WITHIN THE     00027600
*                             DATA SET                                  00027700
DECCCWDI EQU   BIT4 -         A WRITE-BY-IDENTIFICATION (DI) ADDRESSED  00027800
*                             RECORD ZERO                               00027900
DECCCSDK EQU   BIT5 -         A SEARCH-ON-KEY (DK) WAS SPECIFIED WITH   00028000
*                             THE DCBKEYLE FIELD SET TO ZERO OR WITHOUT 00028100
*                             AN ADDRESS FOR THE KEY                    00028200
DECCCOPT EQU   BIT6 -         A MACRO INSTRUCTION USED AN OPTION NOT    00028300
*                             SET IN THE DCB                            00028400
DECCCKFF EQU   BIT7 -         THE KEY FOR THE FIXED-LENGTH RECORD TO BE 00028500
*                             ADDED BEGINS WITH X'FF'                   00028600
DECRSV34 DS    X -            RESERVED                                  00028700
         DS    0BL2 -         DECTYPE - TYPE OF I/O REQUEST             00028800
         DS    B -            DECTYPE1 - FIRST BYTE OF DECTYPE          00028900
DECVERFY EQU   BIT0 -         VERIFY                                    00029000
DECOFLOW EQU   BIT1 -         OVERFLOW                                  00029100
DECEXSRC EQU   BIT2 -         EXTENDED SEARCH                           00029200
DECFDBCK EQU   BIT3 -         FEEDBACK                                  00029300
DECACTAD EQU   BIT4 -         ACTUAL ADDRESSING                         00029400
DECDYNBF EQU   BIT5 -         DYNAMIC BUFFERING                         00029500
DECRDEX  EQU   BIT6 -         READ EXCLUSIVE                            00029600
DECRELBA EQU   BIT7 -         RELATIVE BLOCK ADDRESSING                 00029700
         DS    B -            DECTYPE2 - SECOND BYTE OF DECTYPE         00029800
DECKEYS  EQU   BIT0 -         S CODED FOR KEY ADDRESS                   00029900
DECBKLNS EQU   BIT1 -         S CODED FOR BLOCK LENGTH                  00030000
DECTYPRU EQU   BIT2+BIT3 -    RU IS SUFFIXED TO THE TYPE, INDICATING    00030100
*                             THAT THE FEEDBACK ADDRESS POINTED TO BY   00030200
*                             DECNXADR CAN BE THE ADDRESS OF EITHER THE 00030300
*                             NEXT DATA RECORD OR THE NEXT CAPACITY     00030400
*                             RECORD, WHICHEVER OCCURS FIRST            00030500
DECTYPR  EQU   BIT3 -         R IS SUFFIXED TO THE TYPE, INDICATING     00030600
*                             THAT THE FEEDBACK ADDRESS POINTED TO BY   00030700
*                             DECNXADR IS THE ADDRESS OF THE NEXT DATA  00030800
*                             RECORD.  (BIT 2 IS ZERO)                  00030900
DECOPRD  EQU   BIT4 -         TYPE OF OPERATION - 0 IS WRITE, 1 IS READ 00031000
DECSRKEY EQU   BIT5 -         TYPE OF SEARCH ARGUMENT - 0 IS ID,        00031100
*                             1 IS KEY                                  00031200
DECWRADD EQU   BIT6 -         ADD OPTION OF WRITE OPERATION             00031300
DECRSV35 EQU   BIT7,,C'X' -   RESERVED                                  00031400
         DS    H -            DECLNGTH - LENGTH OF DATA                 00031500
         DS    A -            DECDCBAD - ADDRESS OF DCB TO WHICH THIS   00031600
*                             I/O REQUEST IS RELATED                    00031700
         DS    A -            DECAREA - ADDRESS OF THE DATA             00031800
         DS    A -            DECIOBPT - ADDRESS OF THE IOB             00031900
DECKYADR DS    A -            ADDRESS OF THE KEY                        00032000
DECRECPT DS    A -            ADDRESS OF THE BLOCK REFERENCE FIELD      00032100
DECNA    DS    0A -           SAME AS DECNAA BELOW                      00032200
DECRSV36 DS    X -            RESERVED                                  00032300
DECNAA   DS    AL3 -          ADDRESS OF THE NEXT ADDRESS FEEDBACK      00032400
*                             FIELD.  PRESENT ONLY IF R OR RU IS CODED  00032500
*                             IN THE READ MACRO.                        00032600
         SPACE 2                                                        00032700
*********************************************************************** 00032800
*              DATA EVENT CONTROL BLOCK FOR QTAM                      * 00032900
*********************************************************************** 00033000
         SPACE 1                                                        00033100
         ORG   DECB                                                     00033200
LINEDECB DS    CL4 -          ALWAYS ZERO                               00033300
DECRSV37 DS    X -            RESERVED                                  00033400
DECOPCOD DS    C -            OPERATION CODE FOR CURRENT SEGMENT        00033500
         DS    H -            DECLNGTH - LENGTH OF INPUT AREA FOR       00033600
*                             INITIAL READ                              00033700
         DS    A -            DECDCBAD - ADDRESS OF DCB                 00033800
         DS    A -            DECAREA - STARTING ADDRESS FOR DATA IN A  00033900
*                             BUFFER                                    00034000
DECRSV38 DS    XL4 -          RESERVED                                  00034100
DECCPOL  DS    0A -           SAME AS DECCPOLA BELOW                    00034200
DECNMMSG DS    FL1 -          NUMBER OF MESSAGES RECEIVED               00034300
DECCPOLA DS    AL3 -          ADDRESS OF CURRENTLY ACTIVE ENTRY IN      00034400
*                             POLLING LIST                              00034500
DECRSV39 DS    X -            RESERVED                                  00034600
DECUCBDX DS    FL1 -          INDEX TO UCB ADDRESS IN DEB               00034700
DECRSV40 DS    XL2 -          RESERVED                                  00034800
DECRSV41 DS    XL4 -          RESERVED                                  00034900
DECADRCH DS    A -            ADDRESS OF ADDRESSING CHARACTERS IN       00035000
*                             TERMINAL ENTRY                            00035100
         DS    0A -           DECPOLPT - ADDRESS OF POLLING LIST        00035200
DECRSV42 DS    X -            RESERVED                                  00035300
         DS    AL3 -          DECPOLPA - ADDRESS OF POLLING LIST        00035400
         SPACE 2                                                        00035500
*********************************************************************** 00035600
*              DATA EVENT CONTROL BLOCK FOR BTAM                      * 00035700
*********************************************************************** 00035800
         SPACE 1                                                        00035900
         ORG   DECB                                                     00036000
         DS    CL4 -          DECSDECB - EVENT CONTROL BLOCK            00036100
         DS    0BL2 -         DECTYPE - PROGRAMMING INDICATORS          00036200
         DS    B -            DECTYPE1 - FIRST BYTE OF DECTYPE          00036300
DECRDAPL EQU   BIT0 -         READ, USING AUTOPOLL                      00036400
DECRSV43 EQU   BIT1,,C'X' -   RESERVED                                  00036500
DECRSV44 EQU   BIT2,,C'X' -   RESERVED                                  00036600
DECRSV45 EQU   BIT3,,C'X' -   RESERVED                                  00036700
DECRSV46 EQU   BIT4,,C'X' -   RESERVED                                  00036800
DECSTRME EQU   BIT5 -         'S' CODED FOR TERMINAL ENTRY              00036900
DECSAREA EQU   BIT6 -         'S' CODED FOR AREA                        00037000
DECSLNTH EQU   BIT7 -         'S' CODED FOR LENGTH                      00037100
         DS    C -            DECTYPE2 - COMMAND CODE                   00037200
         DS    H -            DECLNGTH - LENGTH OF BUFFER OR MESSAGE    00037300
*                             AREA                                      00037400
         DS    0A -           DECDCBAD - ADDRESS OF ASSOCIATED DCB      00037500
DECBUFCT DS    0FL1 -         CONTAINS A RUNNING COUNT OF BUFFERS       00037600
*                             OBTAINED BY BTAM FOR THE CURRENT READ     00037700
*                             OPERATION.  (DYNAMIC BUFFERING ONLY.)     00037800
*                             USE DIFFERS DURING BSC AND 2760 ONLINE    00037900
*                             TEST.                                     00038000
DECONLTT DS    B -            FLAG BYTE FOR BSC AND 2760 ONLINE TEST    00038100
DECONLTS EQU   BIT0 -         IF ZERO, ONLINE TEST REQUESTED BY RFT     00038200
*                             MESSAGE (BSC).  IF ONE, ONLINE TEST       00038300
*                             INITIATED BY ONLTST MACRO INSTRUCTION     00038400
*                             (BSC).                                    00038500
DECRCVMS EQU   BIT1 -         IF ZERO, SENDING TEST MESSAGES (BSC).     00038600
*                             IF ONE, RECEIVING TEST MESSAGES (BSC) OR  00038700
*                             TYPE 11 ONLINE TEST FOR 2760 OPTICAL      00038800
*                             IMAGE UNIT.                               00038900
DECRSV47 EQU   BIT2,,C'X' -   RESERVED                                  00039000
DECRSV48 EQU   BIT3,,C'X' -   RESERVED                                  00039100
DECRSV49 EQU   BIT4,,C'X' -   RESERVED                                  00039200
DECRSV50 EQU   BIT5,,C'X' -   RESERVED                                  00039300
DECRSV51 EQU   BIT6,,C'X' -   RESERVED                                  00039400
DECRSV52 EQU   BIT7,,C'X' -   RESERVED                                  00039500
DECDCBAA DS    AL3 -          ADDRESS OF ASSOCIATED DCB                 00039600
         DS    A -            DECAREA - ADDRESS OF BUFFER OR MESSAGE    00039700
*                             AREA                                      00039800
DECSENS0 DS    B -            SENSE INFORMATION                         00039900
DECSENS1 DS    B -            RESERVED                                  00040000
DECCOUNT DS    H -            RESIDUAL COUNT FROM CSW FOR LAST CCW      00040100
*                             EXECUTED                                  00040200
DECENTRY DS    0A -           ADDRESS OF THE TERMINAL LIST              00040300
DECCMCOD DS    C -            COMMAND FOR WHICH THE ERROR OCCURRED      00040400
DECENTRA DS    AL3 -          ADDRESS OF THE TERMINAL LIST              00040500
DECFLAGS DS    B -            OPERATION STATUS                          00040600
DECWACK  EQU   BIT0+BIT1 -    WACK WAS RECEIVED (BSC)                   00040700
DECERRMS EQU   BIT0 -         ERROR STATUS MESSAGE WAS RECEIVED (BSC).  00040800
*                             BIT 1 IS OFF.                             00040900
DECDIFAC EQU   BIT1 -         ACKNOWLEDGMENT OTHER THAN ACK-0 OR ACK-1  00041000
*                             RECEIVED (BSC)                            00041100
DECALTAC EQU   BIT2 -         ACKNOWLEDGMENT ALTERNATION INCORRECT      00041200
DECBADID EQU   BIT3 -         FOR TWX 33/35 STATION AND BSC STATION,    00041300
*                             INCORRECT ID RECEIVED.  FOR AUTOPOLL,     00041400
*                             INDEX BYTE RECEIVED DOES NOT MATCH AN     00041500
*                             ACTIVE ONE.  FOR BSC NONSWITCHED          00041600
*                             POINT-TO-POINT LINE, CONTENTION OCCURRED. 00041700
*                             FOR WTTA, CONTENTION OCCURRED OR          00041800
*                             INCORRECT ID RECEIVED.                    00041900
DECNOBUF EQU   BIT4 -         FOR READ, DYNAMIC BUFFERING, NO BUFFER    00042000
*                             WAS AVAILABLE.  (MESSAGE LOST)            00042100
DECNEGRP EQU   BIT5 -         FOR OPENLST, POLLING, NEGATIVE RESPONSE   00042200
*                             TO POLLING RECEIVED.  FOR WRAPLST, ALL    00042300
*                             ENTRIES ARE INACTIVE.  FOR ADDRESSING,    00042400
*                             NEGATIVE RESPONSE TO ADDRESSING           00042500
*                             RECEIVED.  FOR WTTA, LAST MESSAGE         00042600
*                             RECEIVED ENDED WITH EOT OR TIME-OUT.      00042700
*                             FOR 2741, POWER IS OFF OR OTHER           00042800
*                             INTERVENTION REQUIRED CONDITION EXISTS.   00042900
DECREVRS EQU   BIT6 -         FOR WTTA, MESSAGE ENDED WITH WRU SIGNAL.  00043000
*                             FOR BSC STATIONS, REVERSE INTERRUPT (RVI) 00043100
*                             SEQUENCE WAS RECEIVED (SEE ALSO BIT 1).   00043200
*                             FOR 2741, WRITE OPERATION WAS ENDED BY    00043300
*                             TERMINAL INTERRUPT.                       00043400
DECSSMSG EQU   BIT6 -         A 3270 REMOTE SENSE/STATUS MESSAGE WAS    00043500
*                             RECEIVED IF THIS BIT IS ONE AND BIT 1     00043600
*                             IS ZERO                            ICB479 00043700
DECSTXNQ EQU   BIT7 -         FOR WTTA, CONTENTION CONDITION WAS        00043800
*                             ENCOUNTERED.  FOR BSC STATIONS, STX ENQ   00043900
*                             SEQUENCE WAS RECEIVED.                    00044000
DECRLN   DS    FL1 -          RELATIVE LINE NUMBER                      00044100
DECRESPN DS    CL2 -          FOR BSC OPERATIONS, RESPONSE FROM A       00044200
*                             TERMINAL TO ADDRESSING.  FOR STOP-START   00044300
*                             OPERATIONS, BYTE 1 IS RESPONSE FROM A     00044400
*                             TERMINAL TO ADDRESSING AND BYTE 2 IS      00044500
*                             VERTICAL REDUNDANCY CHARACTER AND         00044600
*                             LONGITUDINAL REDUNDANCY CHARACTER         00044700
*                             (VRC/LRC) RESPONSE.                       00044800
DECTPCOD DS    C -            TP OPERATION CODE                         00044900
DECERRST DS    B -            I/O ERROR STATUS FLAGS                    00045000
DECSIO3  EQU   BIT0 -         SIO RESULTED IN A CONDITION CODE OF 3     00045100
DECUNDEF EQU   BIT1 -         UNDEFINED ERROR CONDITION                 00045200
DECERPER EQU   BIT2 -         AN ERROR CONDITION OCCURRED DURING AN I/O 00045300
*                             OPERATION INITIATED BY ERROR RECOVERY     00045400
*                             ROUTINES                                  00045500
DECDIAGN EQU   BIT3 -         DIAGNOSTIC WRITE/READ OPERATION ENDED     00045600
*                             BECAUSE OF ERROR (2701 ONLY)              00045700
DECDSABL EQU   BIT4 -         DISABLE COMMAND ISSUED TO SWITCHED LINE   00045800
*                             BY ERROR RECOVERY ROUTINE BECAUSE OF      00045900
*                             PERMANENT ERROR ON THAT LINE              00046000
DECRSV53 EQU   BIT5,,C'X' -   RESERVED                                  00046100
DECRSV54 EQU   BIT6,,C'X' -   RESERVED                                  00046200
DECRSV55 EQU   BIT7,,C'X' -   RESERVED                                  00046300
DECCSWST DS    BL2 -          STATUS BITS FROM CSW FOR LAST CCW         00046400
*                             EXECUTED                                  00046500
DECADRPT DS    A -            ADDRESS OF ADDRESSING LIST ENTRY USED IN  00046600
*                             PREVIOUS OPERATION                        00046700
DECPOLPT DS    0A -           SAME AS DECPOLPA BELOW                    00046800
DECNDXPL DS    FL1 -          FOR AUTOPOLL, INDEX TO CURRENT ENTRY IN   00046900
*                             POLLING LIST                              00047000
DECPOLPA DS    AL3 -          FOR PROGRAMMED POLLING, ADDRESS OF THE    00047100
*                             CURRENT ENTRY IN THE POLLING LIST.  FOR   00047200
*                             AUTOPOLL, ADDRESS OF POLLING LIST.  FOR   00047300
*                             BSC ON-LINE TEST, ADDRESS OF TEXT DATA.   00047400
         SPACE 1                                                        00047500
*              BSC EXTENSION                                            00047600
*        FIELDS ARE PRESENT ONLY IF A SUBLIST IS CODED FOR THE          00047700
*        AREA AND LENGTH OPERANDS OF THE READ OR WRITE MACRO            00047800
*        INSTRUCTION THAT DEFINES THE DECB.                             00047900
         SPACE 1                                                        00048000
DECRSV56 DS    XL2 -          RESERVED                                  00048100
DECWLNG  DS    H -            LENGTH, IN BYTES, OF THE DATA AREA IN     00048200
*                             LEADING-GRAPHICS AND CONVERSATIONAL TYPE  00048300
*                             OPERATIONS OR OF THE AREA CONTAINING THE  00048400
*                             TONE CHARACTERS IN READ CONNECT WITH TONE 00048500
*                             (TCW) OPERATIONS                          00048600
DECWAREA DS    A -            ADDRESS OF THE DATA AREA IN               00048700
*                             LEADING-GRAPHICS AND CONVERSATIONAL       00048800
*                             OPERATIONS, OR OF THE AREA CONTAINING THE 00048900
*                             TONE CHARACTERS IN READ TCW OPERATIONS    00049000
         MEND  , */                                                     00049100
*%DECBL2 :  ;                                                           00049200
*                                                                       00049300
*                                                                       00049400
*/* **************************************************************** */ 00049500
*/*            DATA EVENT CONTROL BLOCK FOR BSAM                     */ 00049600
*/* **************************************************************** */ 00049700
*                                                                       00049800
*DECLARE                                                                00049900
*  1 DECB     BASED(DECBPT) BDY(WORD),                                  00050000
*   2 DECSDECB    CHAR(4) BDY(WORD),     /* EVENT CONTROL BLOCK      */ 00050100
*   2 DECBPTR     PTR(31),               /* FOR IBM 1419 MAGNETIC       00050200
*                                           CHARACTER READER AND        00050300
*                                           IBM 1275 OPTICAL READER     00050400
*                                           SORTER, A POINTER TO        00050500
*                                           NEXT DECB TO BE TESTED      00050600
*                                           FOR COMPLETION BY THE       00050700
*                                           CHECK MACRO INSTRUCTION.    00050800
*                                           (DECB CHAINING APPLIES TO   00050900
*                                           THE USE OF MORE THAN ONE    00051000
*                                           DEVICE.)  THIS FIELD IN     00051100
*                                           THE LAST DECB MUST BE       00051200
*                                           ZERO.                    */ 00051300
*    3 DECTYPE     CHAR(2),              /* TYPE OF I/O REQUEST      */ 00051400
*     4 DECTYPE1    CHAR(1),             /* TYPE OF LENGTH OPERAND   */ 00051500
*      5 DECLNS   BIT(1),                /* S CODED FOR LENGTH       */ 00051600
*      5 DECRSV01 BIT(1),                /* RESERVED                 */ 00051700
*      5 DECRSV02 BIT(1),                /* RESERVED                 */ 00051800
*      5 DECRSV03 BIT(1),                /* RESERVED                 */ 00051900
*      5 DECRSV04 BIT(1),                /* RESERVED                 */ 00052000
*      5 DECRSV05 BIT(1),                /* RESERVED                 */ 00052100
*      5 DECRSV06 BIT(1),                /* RESERVED                 */ 00052200
*      5 DECRSV07 BIT(1),                /* RESERVED                 */ 00052300
*     4 DECTYPE2    CHAR(1),             /* TYPE OF OPERATION        */ 00052400
*      5 DECRDSF  BIT(1),                /* READ SF                  */ 00052500
*      5 DECRDSB  BIT(1),                /* READ SB                  */ 00052600
*      5 DECWRSF  BIT(1),                /* WRITE SF                 */ 00052700
*      5 DECWRSD  BIT(1),                /* WRITE SD                 */ 00052800
*      5 DECRSV08 BIT(1),                /* RESERVED                 */ 00052900
*      5 DECWRSZ  BIT(1),                /* WRITE SZ                 */ 00053000
*      5 DECRSV09 BIT(1),                /* RESERVED                 */ 00053100
*      5 DECWRSFR BIT(1),                /* WRITE SFR (BIT 2 IS ALSO    00053200
*                                           ON) OR READ RBL (BIT 0 IS   00053300
*                                           ALSO ON)           MDC004*/ 00053400
*    3 DECLNGTH    FIXED(15),            /* LENGTH OF KEY AND DATA   */ 00053500
*   2 DECDCBAD    PTR(31),               /* ADDRESS OF THE DCB TO       00053600
*                                           WHICH THIS I/O REQUEST      00053700
*                                           IS RELATED               */ 00053800
*   2 DECAREA     PTR(31),               /* ADDRESS OF KEY AND DATA,    00053900
*                                           OR FOR 1287 OR 1288         00054000
*                                           OPTICAL READERS, ADDRESS    00054100
*                                           OF A USER-SPECIFIED         00054200
*                                           CHANNEL PROGRAM          */ 00054300
*   2 DECIOBPT    PTR(31),               /* ADDRESS OF THE IOB       */ 00054400
*   2 DECNEXT     PTR(31),               /* SAME AS DECNEXTA BELOW   */ 00054500
*    3 DECRSV10    CHAR(1),              /* RESERVED                 */ 00054600
*    3 DECNEXTA    PTR(24);              /* ADDRESS OF THE NEXT         00054700
*                                           ADDRESS FEEDBACK FIELD.     00054800
*                                           PRESENT ONLY IF R IS        00054900
*                                           CODED IN THE WRITE MACRO.*/ 00055000
*                                                                       00055100
*                                                                       00055200
*DECLARE 1 DECBS05                                                      00055300
*%IF IKEPLS='2'  %THEN                                                  00055400
*    %GOTO DECBA1;                                                      00055500
*      BASED(ADDR(DECNEXT)) BDY(WORD),                                  00055600
*%GOTO DECBA2;                                                          00055700
*%DECBA1 : ;                                                            00055800
*      DEF(DECNEXT) BDY(WORD),                                          00055900
*%DECBA2 : ;                                                            00056000
*                                        /* FOR 3886 ONLY, DEVICE       00056100
*                                           DEPENDENT FIELDS         */ 00056200
*   2 DECBHDRA    PTR(31),               /* FOR READ RBL, ADDRESS OF    00056300
*                                           3886 DATA HEADER RECORD     00056400
*                                           AFTER READ         MDC001*/ 00056500
*   2 DECBLNNM    PTR(31),               /* FOR READ RBL, ADDRESS OF    00056600
*                                           LINE NUMBER OR NEGATIVE     00056700
*                                           OF LINE NUMBER     MDC002*/ 00056800
*   2 DECBLFMT    PTR(31);               /* FOR READ RBL, ADDRESS OF    00056900
*                                           LINE FORMAT NUMBER OR       00057000
*                                           NEGATIVE OF LINE FORMAT     00057100
*                                           NUMBER             MDC003*/ 00057200
*                                                                       00057300
*                                                                       00057400
*/* **************************************************************** */ 00057500
*/*            DATA EVENT CONTROL BLOCK FOR BISAM                    */ 00057600
*/* **************************************************************** */ 00057700
*                                                                       00057800
*DECLARE 1  DECBS01                                                     00057900
*      BASED(DECBPT) BDY(WORD),                                         00058000
*   2 DECBECB     CHAR(4)  BDY(WORD),    /* EVENT CONTROL BLOCK      */ 00058100
*    3 DECBRB      PTR(31),              /* SAME AS DECBRBA BELOW    */ 00058200
*     4 DECBECBF    CHAR(1),             /* FLAG FIELD               */ 00058300
*      5 DECBWAIT BIT(1),                /* AWAITING COMPLETION OF      00058400
*                                           EVENT                    */ 00058500
*      5 DECBPOST BIT(1),                /* EVENT HAS COMPLETED         00058600
*                                           NORMALLY OR ABNORMALLY.     00058700
*                                           IF THE EVENT COMPLETED      00058800
*                                           ABNORMALLY, FIELDS          00058900
*                                           DECBEXC1 AND DECBEXC2       00059000
*                                           WILL SHOW THE REASON.    */ 00059100
*      5 DECRSV11 BIT(1),                /* RESERVED                 */ 00059200
*      5 DECRSV12 BIT(1),                /* RESERVED                 */ 00059300
*      5 DECRSV13 BIT(1),                /* RESERVED                 */ 00059400
*      5 DECRSV14 BIT(1),                /* RESERVED                 */ 00059500
*      5 DECRSV15 BIT(1),                /* RESERVED                 */ 00059600
*      5 DECRSV16 BIT(1),                /* RESERVED                 */ 00059700
*     4 DECBRBA     PTR(24),             /* ADDRESS OF THE RB FOR       00059800
*                                           THE PROGRAM AWAITING        00059900
*                                           EVENT (BEFORE EVENT         00060000
*                                           COMPLETION) OR RESERVED     00060100
*                                           (AFTER EVENT COMPLETION) */ 00060200
*   2 DECBTYP1    CHAR(1),               /* OPTION BYTE              */ 00060300
*    3 DECRSV17 BIT(1),                  /* RESERVED                 */ 00060400
*    3 DECRSV18 BIT(1),                  /* RESERVED                 */ 00060500
*    3 DECRSV19 BIT(1),                  /* RESERVED                 */ 00060600
*    3 DECRSV20 BIT(1),                  /* RESERVED                 */ 00060700
*    3 DECRSV21 BIT(1),                  /* RESERVED                 */ 00060800
*    3 DECRSV22 BIT(1),                  /* RESERVED                 */ 00060900
*    3 DECBLNS  BIT(1),                  /* LENGTH CODED AS 'S'      */ 00061000
*    3 DECBARS  BIT(1),                  /* AREA CODED AS 'S'        */ 00061100
*   2 DECBTYP2    CHAR(1),               /* TYPE OF I/O REQUEST      */ 00061200
*    3 DECBRDK  BIT(1),                  /* READ K                   */ 00061300
*    3 DECRSV23 BIT(1),                  /* RESERVED                 */ 00061400
*    3 DECBRDKU BIT(1),                  /* READ KU                  */ 00061500
*    3 DECRSV24 BIT(1),                  /* RESERVED                 */ 00061600
*    3 DECBWRK  BIT(1),                  /* WRITE K                  */ 00061700
*    3 DECBWRKN BIT(1),                  /* WRITE KN                 */ 00061800
*    3 DECRSV25 BIT(1),                  /* RESERVED                 */ 00061900
*    3 DECRSV26 BIT(1),                  /* RESERVED                 */ 00062000
*   2 DECBLGTH    FIXED(15),             /* NUMBER OF BYTES READ OR     00062100
*                                           WRITTEN                  */ 00062200
*   2 DECBDCBA    PTR(31),               /* ADDRESS OF THE DATA         00062300
*                                           CONTROL BLOCK            */ 00062400
*   2 DECBAREA    PTR(31),               /* ADDRESS OF THE AREA IN      00062500
*                                           STORAGE FOR THE RECORD   */ 00062600
*   2 DECBLOGR    PTR(31),               /* ADDRESS OF THE LOGICAL      00062700
*                                           RECORD                   */ 00062800
*   2 DECBKEY     PTR(31),               /* ADDRESS OF THE KEY          00062900
*                                           PORTION OF THE RECORD    */ 00063000
*   2 DECBEXC1    CHAR(1),               /* EXCEPTIONAL CONDITION       00063100
*                                           CODE BYTE 1              */ 00063200
*    3 DECEXRNF BIT(1),                  /* RECORD NOT FOUND         */ 00063300
*    3 DECEXRLC BIT(1),                  /* RECORD LENGTH CHECK      */ 00063400
*    3 DECEXNSP BIT(1),                  /* SPACE NOT FOUND IN WHICH    00063500
*                                           TO ADD A RECORD          */ 00063600
*    3 DECEXINV BIT(1),                  /* INVALID REQUEST          */ 00063700
*    3 DECEXERR BIT(1),                  /* UNCORRECTABLE I/O ERROR  */ 00063800
*    3 DECEXUBK BIT(1),                  /* UNREACHABLE BLOCK        */ 00063900
*    3 DECEXOFL BIT(1),                  /* OVERFLOW RECORD          */ 00064000
*    3 DECEXDUP BIT(1),                  /* DUPLICATE RECORD            00064100
*                                           PRESENTED FOR INCLUSION     00064200
*                                           IN THE DATA SET          */ 00064300
*   2 DECBEXC2    CHAR(1),               /* EXCEPTIONAL CONDITION       00064400
*                                           CODE BYTE 2              */ 00064500
*    3 DECRSV27 BIT(1),                  /* RESERVED                 */ 00064600
*    3 DECRSV28 BIT(1),                  /* RESERVED                 */ 00064700
*    3 DECRSV29 BIT(1),                  /* RESERVED                 */ 00064800
*    3 DECRSV30 BIT(1),                  /* RESERVED                 */ 00064900
*    3 DECRSV31 BIT(1),                  /* RESERVED                 */ 00065000
*    3 DECRSV32 BIT(1),                  /* RESERVED                 */ 00065100
*    3 DECEXASR BIT(1),                  /* EXECUTION OF THE LAST       00065200
*                                           CHANNEL PROGRAM WAS         00065300
*                                           INSTITUTED BY AN            00065400
*                                           ASYNCHRONOUS ROUTINE     */ 00065500
*    3 DECEXRKU BIT(1);                  /* PREVIOUS MACRO              00065600
*                                           INSTRUCTION WAS READ KU  */ 00065700
*                                                                       00065800
*                                                                       00065900
*/* **************************************************************** */ 00066000
*/*            DATA EVENT CONTROL BLOCK FOR BDAM                     */ 00066100
*/* **************************************************************** */ 00066200
*                                                                       00066300
*DECLARE 1  DECBS02                                                     00066400
*      BASED(DECBPT) BDY(WORD),                                         00066500
*   2 *           CHAR(4)  BDY(WORD),    /* DECSDECB - EVENT CONTROL    00066600
*                                           BLOCK                    */ 00066700
*    3 *           CHAR(1),              /* COMPLETION CODE BYTE 1   */ 00066800
*    3 DECCC2      CHAR(1),              /* COMPLETION CODE BYTE 2   */ 00066900
*     4 DECCCRNF BIT(1),                 /* RECORD NOT FOUND         */ 00067000
*     4 DECCCRLC BIT(1),                 /* RECORD LENGTH CHECK      */ 00067100
*     4 DECCCNSP BIT(1),                 /* SPACE NOT FOUND          */ 00067200
*     4 DECCCINV BIT(1),                 /* INVALID REQUEST.  (THIS     00067300
*                                           CONDITION ALSO SETS A BIT   00067400
*                                           IN THE NEXT BYTE.)       */ 00067500
*     4 DECCCERR BIT(1),                 /* UNCORRECTABLE I/O ERROR  */ 00067600
*     4 DECCCEOD BIT(1),                 /* END OF DATA              */ 00067700
*     4 DECCCUER BIT(1),                 /* UNCORRECTABLE ERROR OTHER   00067800
*                                           THAN AN I/O ERROR        */ 00067900
*     4 DECCCREX BIT(1),                 /* A WRITE WITH EXCLUSIVE      00068000
*                                           CONTROL WAS NOT PRECEDED    00068100
*                                           BY A READ WITH EXCLUSIVE    00068200
*                                           CONTROL (MDC300) @Z30AQ9A*/ 00068300
*    3 DECCC3      CHAR(1),              /* COMPLETION CODE BYTE 3   */ 00068400
*     4 DECRSV33 BIT(1),                 /* RESERVED                 */ 00068500
*     4 DECCCWRI BIT(1),                 /* A WRITE MACRO INSTRUCTION   00068600
*                                           WAS ADDRESSED TO AN INPUT   00068700
*                                           DATA SET                 */ 00068800
*     4 DECCCEXS BIT(1),                 /* AN EXTENDED SEARCH WAS      00068900
*                                           SPECIFIED WITH DCBLIMCT     00069000
*                                           FIELD SET TO ZERO        */ 00069100
*     4 DECCCNBK BIT(1),                 /* THE BLOCK REQUESTED IS      00069200
*                                           NOT WITHIN THE DATA SET  */ 00069300
*     4 DECCCWDI BIT(1),                 /* A WRITE-BY-IDENTIFICATION   00069400
*                                           (DI) ADDRESSED RECORD       00069500
*                                           ZERO                     */ 00069600
*     4 DECCCSDK BIT(1),                 /* A SEARCH-ON-KEY (DK) WAS    00069700
*                                           SPECIFIED WITH THE          00069800
*                                           DCBKEYLE FIELD SET TO       00069900
*                                           ZERO OR WITHOUT AN          00070000
*                                           ADDRESS FOR THE KEY      */ 00070100
*     4 DECCCOPT BIT(1),                 /* A MACRO INSTRUCTION USED    00070200
*                                           AN OPTION NOT SET IN        00070300
*                                           THE DCB                  */ 00070400
*     4 DECCCKFF BIT(1),                 /* THE KEY FOR THE FIXED-      00070500
*                                           LENGTH RECORD TO BE         00070600
*                                           ADDED BEGINS WITH X'FF'  */ 00070700
*    3 DECRSV34    CHAR(1),              /* RESERVED                 */ 00070800
*   2 *           CHAR(2),               /* DECTYPE - TYPE OF I/O       00070900
*                                           REQUEST                  */ 00071000
*    3 *           CHAR(1),              /* DECTYPE1 - FIRST BYTE OF    00071100
*                                           DECTYPE                  */ 00071200
*     4 DECVERFY BIT(1),                 /* VERIFY                   */ 00071300
*     4 DECOFLOW BIT(1),                 /* OVERFLOW                 */ 00071400
*     4 DECEXSRC BIT(1),                 /* EXTENDED SEARCH          */ 00071500
*     4 DECFDBCK BIT(1),                 /* FEEDBACK                 */ 00071600
*     4 DECACTAD BIT(1),                 /* ACTUAL ADDRESSING        */ 00071700
*     4 DECDYNBF BIT(1),                 /* DYNAMIC BUFFERING        */ 00071800
*     4 DECRDEX  BIT(1),                 /* READ EXCLUSIVE           */ 00071900
*     4 DECRELBA BIT(1),                 /* RELATIVE BLOCK ADDRESSING*/ 00072000
*    3 *           CHAR(1),              /* DECTYPE2 - SECOND BYTE      00072100
*                                           OF DECTYPE               */ 00072200
*     4 DECKEYS  BIT(1),                 /* S CODED FOR KEY ADDRESS  */ 00072300
*     4 DECBKLNS BIT(1),                 /* S CODED FOR BLOCK LENGTH */ 00072400
*     4 DECTYPRU BIT(2),                 /* RU IS SUFFIXED TO THE       00072500
*                                           TYPE, INDICATING THAT THE   00072600
*                                           FEEDBACK ADDRESS POINTED    00072700
*                                           TO BY DECNXADR CAN BE THE   00072800
*                                           ADDRESS OF EITHER THE       00072900
*                                           NEXT DATA RECORD OR THE     00073000
*                                           NEXT CAPACITY RECORD,       00073100
*                                           WHICHEVER OCCURS FIRST   */ 00073200
*      5 DECTYPU  BIT(1),                /* OFF IF R IS SUFFIXED,       00073300
*                                           ONE IF RU IS SUFFIXED    */ 00073400
*      5 DECTYPR  BIT(1),                /* R IS SUFFIXED TO THE TYPE,  00073500
*                                           INDICATING THAT THE         00073600
*                                           FEEDBACK ADDRESS POINTED    00073700
*                                           TO BY DECNXADR IS THE       00073800
*                                           ADDRESS OF THE NEXT DATA    00073900
*                                           RECORD  (BIT 2 IS ZERO)  */ 00074000
*     4 DECOPRD  BIT(1),                 /* TYPE OF OPERATION - 0 IS    00074100
*                                           WRITE, 1 IS READ         */ 00074200
*     4 DECSRKEY BIT(1),                 /* TYPE OF SEARCH ARGUMENT     00074300
*                                           - 0 IS ID,  1 IS KEY     */ 00074400
*     4 DECWRADD BIT(1),                 /* ADD OPTION OF WRITE         00074500
*                                           OPERATION                */ 00074600
*     4 DECRSV35 BIT(1),                 /* RESERVED                 */ 00074700
*   2 *           FIXED(15),             /* DECLNGTH - LENGTH OF        00074800
*                                           DATA                     */ 00074900
*   2 *           PTR(31),               /* DECDCBAD - ADDRESS OF       00075000
*                                           DCB TO WHICH THIS I/O       00075100
*                                           REQUEST IS RELATED       */ 00075200
*   2 *           PTR(31),               /* DECAREA - ADDRESS OF THE    00075300
*                                           DATA                     */ 00075400
*   2 *           PTR(31),               /* DECIOBPT - ADDRESS OF THE   00075500
*                                           IOB                      */ 00075600
*   2 DECKYADR    PTR(31),               /* ADDRESS OF THE KEY       */ 00075700
*   2 DECRECPT    PTR(31),               /* ADDRESS OF THE BLOCK        00075800
*                                           REFERENCE FIELD          */ 00075900
*   2 DECNA       PTR(31),               /* SAME AS DECNAA BELOW     */ 00076000
*    3 DECRSV36    CHAR(1),              /* RESERVED                 */ 00076100
*    3 DECNAA      PTR(24);              /* ADDRESS OF THE NEXT         00076200
*                                           ADDRESS FEEDBACK FIELD.     00076300
*                                           PRESENT ONLY IF R OR RU     00076400
*                                           IS CODED IN READ MACRO.  */ 00076500
*                                                                       00076600
*                                                                       00076700
*/* **************************************************************** */ 00076800
*/*            DATA EVENT CONTROL BLOCK FOR QTAM                     */ 00076900
*/* **************************************************************** */ 00077000
*                                                                       00077100
*DECLARE 1  DECBS03                                                     00077200
*      BASED(DECBPT) BDY(WORD),                                         00077300
*   2 LINEDECB    CHAR(4) BDY(WORD),     /* ALWAYS ZERO              */ 00077400
*   2 DECRSV37    CHAR(1),               /* RESERVED                 */ 00077500
*   2 DECOPCOD    CHAR(1),               /* OPERATION CODE FOR          00077600
*                                           CURRENT SEGMENT          */ 00077700
*   2 *           FIXED(15),             /* DECLNGTH - LENGTH OF        00077800
*                                           INPUT AREA FOR INITIAL      00077900
*                                           READ                     */ 00078000
*   2 *           PTR(31),               /* DECDCBAD - ADDRESS OF       00078100
*                                           DCB                      */ 00078200
*   2 *           PTR(31),               /* DECAREA - STARTING          00078300
*                                           ADDRESS FOR DATA IN A       00078400
*                                           BUFFER                   */ 00078500
*   2 DECRSV38    CHAR(4) BDY(WORD),     /* RESERVED                 */ 00078600
*   2 DECCPOL     PTR(31),               /* SAME AS DECCPOLA BELOW   */ 00078700
*    3 DECNMMSG    PTR(8),               /* NUMBER OF MESSAGES          00078800
*                                           RECEIVED                 */ 00078900
*    3 DECCPOLA    PTR(24),              /* ADDRESS OF CURRENTLY        00079000
*                                           ACTIVE ENTRY IN POLLING     00079100
*                                           LIST                     */ 00079200
*   2 DECRSV39    CHAR(1),               /* RESERVED                 */ 00079300
*   2 DECUCBDX    PTR(8),                /* INDEX TO UCB ADDRESS IN     00079400
*                                           DEB                      */ 00079500
*   2 DECRSV40    CHAR(2) BDY(WORD,3),   /* RESERVED                 */ 00079600
*   2 DECRSV41    CHAR(4) BDY(WORD),     /* RESERVED                 */ 00079700
*   2 DECADRCH    PTR(31),               /* ADDRESS OF ADDRESSING       00079800
*                                           CHARACTERS IN TERMINAL      00079900
*                                           ENTRY                    */ 00080000
*   2 *           PTR(31),               /* DECPOLPT - ADDRESS OF       00080100
*                                           POLLING LIST             */ 00080200
*    3 DECRSV42    CHAR(1),              /* RESERVED                 */ 00080300
*    3 *           PTR(24);              /* DECPOLPA - ADDRESS OF       00080400
*                                           POLLING LIST             */ 00080500
*                                                                       00080600
*                                                                       00080700
*/* **************************************************************** */ 00080800
*/*            DATA EVENT CONTROL BLOCK FOR BTAM                     */ 00080900
*/* **************************************************************** */ 00081000
*                                                                       00081100
*DECLARE 1  DECBS04                                                     00081200
*      BASED(DECBPT) BDY(WORD),                                         00081300
*   2 *           CHAR(4) BDY(WORD),     /* DECSDECB - EVENT CONTROL    00081400
*                                           BLOCK                    */ 00081500
*   2 *           CHAR(2),               /* DECTYPE - PROGRAMMING       00081600
*                                           INDICATORS               */ 00081700
*    3 *           CHAR(1),              /* DECTYPE1 - FIRST BYTE OF    00081800
*                                           DECTYPE                  */ 00081900
*     4 DECRDAPL BIT(1),                 /* READ, USING AUTOPOLL     */ 00082000
*     4 DECRSV43 BIT(1),                 /* RESERVED                 */ 00082100
*     4 DECRSV44 BIT(1),                 /* RESERVED                 */ 00082200
*     4 DECRSV45 BIT(1),                 /* RESERVED                 */ 00082300
*     4 DECRSV46 BIT(1),                 /* RESERVED                 */ 00082400
*     4 DECSTRME BIT(1),                 /* 'S' CODED FOR TERMINAL      00082500
*                                           ENTRY                    */ 00082600
*     4 DECSAREA BIT(1),                 /* 'S' CODED FOR AREA       */ 00082700
*     4 DECSLNTH BIT(1),                 /* 'S' CODED FOR LENGTH     */ 00082800
*    3 *           CHAR(1),              /* DECTYPE2 - COMMAND          00082900
*                                           CODE                     */ 00083000
*   2 *           FIXED(15),             /* DECLNGTH - LENGTH OF        00083100
*                                           BUFFER OR MESSAGE AREA   */ 00083200
*   2 *           PTR(31),               /* DECDCBAD - ADDRESS OF       00083300
*                                           ASSOCIATED DCB           */ 00083400
*    3 DECBUFCT    PTR(8),               /* CONTAINS A RUNNING COUNT    00083500
*                                           OF BUFFERS OBTAINED BY      00083600
*                                           BTAM FOR THE CURRENT READ   00083700
*                                           OPERATION.  (DYNAMIC        00083800
*                                           BUFFERING ONLY.)  USE       00083900
*                                           DIFFERS DURING BSC AND      00084000
*                                           2760 ONLINE TEST.        */ 00084100
*     4 DECONLTT    CHAR(1),             /* FLAG BYTE FOR BSC AND       00084200
*                                           2760 ONLINE TEST         */ 00084300
*      5 DECONLTS BIT(1),                /* IF ZERO, ONLINE TEST        00084400
*                                           REQUESTED BY RFT MESSAGE    00084500
*                                           (BSC).  IF ONE, ONLINE      00084600
*                                           TEST INITIATED BY ONLTST    00084700
*                                           MACRO INSTRUCTION (BSC). */ 00084800
*      5 DECRCVMS BIT(1),                /* IF ZERO, SENDING TEST       00084900
*                                           MESSAGES (BSC).  IF ONE,    00085000
*                                           RECEIVING TEST MESSAGES     00085100
*                                           (BSC) OR TYPE 11 ONLINE     00085200
*                                           TEST FOR 2760 OPTICAL       00085300
*                                           IMAGE UNIT.              */ 00085400
*      5 DECRSV47 BIT(1),                /* RESERVED                 */ 00085500
*      5 DECRSV48 BIT(1),                /* RESERVED                 */ 00085600
*      5 DECRSV49 BIT(1),                /* RESERVED                 */ 00085700
*      5 DECRSV50 BIT(1),                /* RESERVED                 */ 00085800
*      5 DECRSV51 BIT(1),                /* RESERVED                 */ 00085900
*      5 DECRSV52 BIT(1),                /* RESERVED                 */ 00086000
*    3 DECDCBAA    PTR(24),              /* ADDRESS OF ASSOCIATED       00086100
*                                           DCB                      */ 00086200
*   2 *           PTR(31),               /* DECAREA - ADDRESS OF        00086300
*                                           BUFFER OR MESSAGE AREA   */ 00086400
*   2 DECSENS0    CHAR(1),               /* SENSE INFORMATION        */ 00086500
*   2 DECSENS1    CHAR(1),               /* RESERVED                 */ 00086600
*   2 DECCOUNT    FIXED(15),             /* RESIDUAL COUNT FROM CSW     00086700
*                                           FOR LAST CCW EXECUTED    */ 00086800
*   2 DECENTRY    PTR(31),               /* ADDRESS OF THE TERMINAL     00086900
*                                           LIST                     */ 00087000
*    3 DECCMCOD    CHAR(1),              /* COMMAND FOR WHICH THE       00087100
*                                           ERROR OCCURRED           */ 00087200
*    3 DECENTRA    PTR(24),              /* ADDRESS OF THE TERMINAL     00087300
*                                           LIST                     */ 00087400
*   2 DECFLAGS    CHAR(1),               /* OPERATION STATUS         */ 00087500
*    3 DECWACK  BIT(2),                  /* WACK WAS RECEIVED (BSC)  */ 00087600
*     4 DECERRMS BIT(1),                 /* ERROR STATUS MESSAGE WAS    00087700
*                                           RECEIVED (BSC).  BIT 1 IS   00087800
*                                           OFF.                     */ 00087900
*     4 DECDIFAC BIT(1),                 /* ACKNOWLEDGMENT OTHER        00088000
*                                           THAN ACK-0 OR ACK-1         00088100
*                                           RECEIVED (BSC)           */ 00088200
*    3 DECALTAC BIT(1),                  /* ACKNOWLEDGMENT              00088300
*                                           ALTERNATION INCORRECT    */ 00088400
*    3 DECBADID BIT(1),                  /* FOR TWX 33/35 STATION       00088500
*                                           AND BSC STATION,            00088600
*                                           INCORRECT ID RECEIVED.      00088700
*                                           FOR AUTOPOLL, INDEX         00088800
*                                           BYTE RECEIVED DOES NOT      00088900
*                                           MATCH AN ACTIVE ONE.        00089000
*                                           FOR BSC NONSWITCHED         00089100
*                                           POINT-TO-POINT LINE,        00089200
*                                           CONTENTION OCCURRED. FOR    00089300
*                                           WTTA, CONTENTION            00089400
*                                           OCCURRED OR INCORRECT       00089500
*                                           ID RECEIVED.             */ 00089600
*    3 DECNOBUF BIT(1),                  /* FOR READ, DYNAMIC           00089700
*                                           BUFFERING, NO BUFFER        00089800
*                                           WAS AVAILABLE. (MESSAGE     00089900
*                                           LOST)                    */ 00090000
*    3 DECNEGRP BIT(1),                  /* FOR OPENLST, POLLING,       00090100
*                                           NEGATIVE RESPONSE TO        00090200
*                                           POLLING RECEIVED.  FOR      00090300
*                                           WRAPLST, ALL ENTRIES        00090400
*                                           ARE INACTIVE.  FOR          00090500
*                                           ADDRESSING, NEGATIVE        00090600
*                                           RESPONSE TO ADDRESSING      00090700
*                                           RECEIVED.  FOR WTTA, LAST   00090800
*                                           MESSAGE RECEIVED ENDED      00090900
*                                           WITH EOT OR TIME-OUT.       00091000
*                                           FOR 2741, POWER IS OFF      00091100
*                                           OR OTHER INTERVENTION       00091200
*                                           REQUIRED CONDITION          00091300
*                                           EXISTS.                  */ 00091400
*    3 DECREVRS BIT(1),                  /* FOR WTTA, MESSAGE ENDED     00091500
*                                           WITH WRU SIGNAL.  FOR       00091600
*                                           BSC STATIONS, REVERSE       00091700
*                                           INTERRUPT (RVI) SEQUENCE    00091800
*                                           WAS RECEIVED (SEE ALSO      00091900
*                                           BIT 1).  FOR 2741, WRITE    00092000
*                                           OPERATION WAS ENDED BY      00092100
*                                           TERMINAL INTERRUPT.      */ 00092200
*     4 DECSSMSG BIT(1),                 /* A 3270 REMOTE SENSE/STATUS  00092300
*                                           MESSAGE WAS RECEIVED IF     00092400
*                                           THIS BIT IS ONE AND BIT 1   00092500
*                                           IS ZERO            ICB479*/ 00092600
*    3 DECSTXNQ BIT(1),                  /* FOR WTTA, CONTENTION        00092700
*                                           CONDITION WAS               00092800
*                                           ENCOUNTERED.  FOR BSC       00092900
*                                           STATIONS, STX ENQ           00093000
*                                           SEQUENCE WAS RECEIVED.   */ 00093100
*   2 DECRLN      PTR(8),                /* RELATIVE LINE NUMBER     */ 00093200
*   2 DECRESPN    CHAR(2),               /* FOR BSC OPERATIONS,         00093300
*                                           RESPONSE FROM A             00093400
*                                           TERMINAL TO ADDRESSING.     00093500
*                                           FOR STOP-START              00093600
*                                           OPERATIONS, BYTE 1 IS       00093700
*                                           RESPONSE FROM A             00093800
*                                           TERMINAL TO ADDRESSING      00093900
*                                           AND BYTE 2 IS VERTICAL      00094000
*                                           REDUNDANCY CHARACTER AND    00094100
*                                           LONGITUDINAL REDUNDANCY     00094200
*                                           CHARACTER  (VRC/LRC)        00094300
*                                           RESPONSE.                */ 00094400
*   2 DECTPCOD    CHAR(1),               /* TP OPERATION CODE        */ 00094500
*   2 DECERRST    CHAR(1),               /* I/O ERROR STATUS FLAGS   */ 00094600
*    3 DECSIO3  BIT(1),                  /* SIO RESULTED IN A           00094700
*                                           CONDITION CODE OF 3      */ 00094800
*    3 DECUNDEF BIT(1),                  /* UNDEFINED ERROR             00094900
*                                           CONDITION                */ 00095000
*    3 DECERPER BIT(1),                  /* AN ERROR CONDITION          00095100
*                                           OCCURRED DURING AN I/O      00095200
*                                           OPERATION INITIATED BY      00095300
*                                           ERROR RECOVERY ROUTINES  */ 00095400
*    3 DECDIAGN BIT(1),                  /* DIAGNOSTIC WRITE/READ       00095500
*                                           OPERATION ENDED BECAUSE     00095600
*                                           OF ERROR (2701 ONLY)     */ 00095700
*    3 DECDSABL BIT(1),                  /* DISABLE COMMAND ISSUED      00095800
*                                           TO SWITCHED LINE BY         00095900
*                                           ERROR RECOVERY ROUTINE      00096000
*                                           BECAUSE OF PERMANENT        00096100
*                                           ERROR ON THAT LINE       */ 00096200
*    3 DECRSV53 BIT(1),                  /* RESERVED                 */ 00096300
*    3 DECRSV54 BIT(1),                  /* RESERVED                 */ 00096400
*    3 DECRSV55 BIT(1),                  /* RESERVED                 */ 00096500
*   2 DECCSWST    CHAR(2),               /* STATUS BITS FROM CSW FOR    00096600
*                                           LAST CCW EXECUTED        */ 00096700
*   2 DECADRPT    PTR(31),               /* ADDRESS OF ADDRESSING       00096800
*                                           LIST ENTRY USED IN          00096900
*                                           PREVIOUS OPERATION       */ 00097000
*   2 DECPOLPT    PTR(31),               /* SAME AS DECPOLPA BELOW   */ 00097100
*    3 DECNDXPL    PTR(8),               /* FOR AUTOPOLL, INDEX TO      00097200
*                                           CURRENT ENTRY IN            00097300
*                                           POLLING LIST             */ 00097400
*    3 DECPOLPA    PTR(24),              /* FOR PROGRAMMED POLLING,     00097500
*                                           ADDRESS OF THE CURRENT      00097600
*                                           ENTRY IN THE POLLING        00097700
*                                           LIST.  FOR AUTOPOLL,        00097800
*                                           ADDRESS OF POLLING LIST.    00097900
*                                           FOR BSC ON-LINE TEST,       00098000
*                                           ADDRESS OF TEXT DATA.    */ 00098100
*                                                                       00098200
*/*            BSC EXTENSION                                         */ 00098300
*/*      FIELDS ARE PRESENT ONLY IF A SUBLIST IS CODED FOR THE       */ 00098400
*/*      AREA AND LENGTH OPERANDS OF THE READ OR WRITE MACRO         */ 00098500
*/*      INSTRUCTION THAT DEFINES THE DECB.                          */ 00098600
*                                                                       00098700
*   2 DECRSV56    CHAR(2),               /* RESERVED                 */ 00098800
*   2 DECWLNG     FIXED(15),             /* LENGTH, IN BYTES, OF        00098900
*                                           THE DATA AREA IN            00099000
*                                           LEADING-GRAPHICS AND        00099100
*                                           CONVERSATIONAL TYPE         00099200
*                                           OPERATIONS OR OF THE AREA   00099300
*                                           CONTAINING THE TONE         00099400
*                                           CHARACTERS IN READ          00099500
*                                           CONNECT WITH TONE (TCW)     00099600
*                                           OPERATIONS               */ 00099700
*   2 DECWAREA    PTR(31);               /* ADDRESS OF THE DATA AREA    00099800
*                                           IN LEADING-GRAPHICS AND     00099900
*                                           CONVERSATIONAL              00100000
*                                           OPERATIONS, OR OF THE       00100100
*                                           AREA CONTAINING THE TONE    00100200
*                                           CHARACTERS IN READ TCW      00100300
*                                           OPERATIONS               */ 00100400
CRC32    CSECT                     ESTABLISH CSECT                      00100500
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * JLM 00100600
* 03/01/2022 Changes required for IFOX00 marked by my initials in * JLM 00100700
* columns 69-71. Macro IHADECB from OS/VS1 used as it is not      * JLM 00100800
* available in MVS 3.8j.                                          * JLM 00100900
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * JLM 00101000
*CRC32    AMODE 24                  ESTABLISH AMODE                 JLM 00101100
*CRC32    RMODE 24                  ESTABLISH RMODE                 JLM 00101200
         YREGS                     REGISTER EQUATES                     00101300
         SAVE  (14,12),,CRC32-&SYSDATE SAVE REGISTERS                   00101400
         LR    R12,R15             LOAD R12 W/EPA ADDRESS               00101500
         USING CRC32,R12           ESTABLISH ADDRESSABLITY              00101600
         LR    R2,R1               SAVE A(CPPL)                         00101700
         USING CPPL,R2                                                  00101800
*        STORAGE OBTAIN,ADDR=(1),LENGTH=WORKLEN   GET STORAGE       JLM 00101900
         GETMAIN R,LV=WORKLEN                                       JLM 00102000
         ST    R13,4(,R1)          ST CALLER'S S/A ADDR IN MY S/A       00102100
         ST    R1,8(,R13)          ST MY S/A ADDR IN CALLER'S S/A       00102200
         LR    R13,R1              LOAD ADDR OF MY S/A IN R13           00102300
         USING WORKAREA,R13                                             00102400
         LA    R3,PPLAREA          LOAD A(PPL)                          00102500
         USING PPL,R3                                                   00102600
         LA    R6,IOPLAREA         LOAD A(IOPL)                         00102700
         USING IOPL,R6                                                  00102800
         XC    DIRSAVE(DIRSAVEL),DIRSAVE     CLEAR AREAS                00102900
         XC    DIRBLKSZ(CLEARLEN),DIRBLKSZ   CLEAR AREAS                00103000
         MVC   CRCDATA,FOXES       INITIALIZE DATA CRC                  00103100
         MVC   CRCDIR,FOXES        INITIALIZE DIR CRC                   00103200
         MVC   CRCTOT,FOXES        INITIALIZE TOTAL CRC                 00103300
         MVC   CRCGRTOT,FOXES      INITIALIZE GRAND TOTAL CRC           00103400
         MVC   PPLUPT,CPPLUPT      SAVE A(UPT)  IN PPL                  00103500
         MVC   PPLCBUF,CPPLCBUF    SAVE A(CBUF) IN PPL                  00103600
         MVC   PPLECT,CPPLECT      SAVE A(ECT)  IN PPL                  00103700
         L     R1,=A(CRCPCL)       LOAD A(PCL)                          00103800
         ST    R1,PPLPCL           SAVE A(PCL)  IN PPL                  00103900
         LA    R1,PDLADDR          LOAD A(PDL)                          00104000
         ST    R1,PPLANS           SAVE A(PDL)  IN PPL                  00104100
         LA    R1,ECB              LOAD A(ECB)                          00104200
         ST    R1,PPLECB           SAVE A(ECB)  IN PPL                  00104300
         ST    R1,IOPLECB          SAVE A(ECB)  IN IOPL                 00104400
         LA    R1,PUTBLK           LOAD A(IOPB)                         00104500
         ST    R1,IOPLIOPB         SAVE A(IOPB) IN IOPL                 00104600
         MVC   IOPLUPT,CPPLUPT     SAVE A(UPT)  IN IOPL                 00104700
         MVC   IOPLECT,CPPLECT     SAVE A(ECT)  IN IOPL                 00104800
         LA    R1,PPL              LOAD A(PPL)                          00104900
         LINK  EP=IKJPARS          PARSE THE PARAMETER                  00105000
         LTR   R15,R15             WAS PARSE SUCCESSFUL?                00105100
         MVC   MSGPART,=CL8'PARSE' SHOW PARSE ERROR TYPE                00105200
         BNZ   MISCERR             GO TELL USER                         00105300
         OI    FLAG1,PARSEOK       SHOW PARSE PERFORMED                 00105400
         L     R2,PPLANS           LOAD A(PDL POINTER)                  00105500
         L     R2,0(,R2)           LOAD A(PDL)                          00105600
         USING IKJPARMD,R2                                              00105700
         DROP  R3,R6                                                    00105800
         TM    DSNAME+6,X'80'      WAS DSNAME SPECIFIED?                00105900
         MVC   MSGPART,=CL8'PARSEDSN'   SHOW PARSE ERROR TYPE           00106000
         BZ    MISCERR             NO, GO TELL USER                     00106100
         L     R1,DSNAME           LOAD A(DSNAME)                       00106200
         LH    R14,DSNAME+4        LOAD LENGTH(DSNAME)                  00106300
         MVI   DSN,C' '            CLEAR ALL                            00106400
         MVC   DSN+1(CHARLEN-1),DSN   CHARACTER FIELDS                  00106500
         BCTR  R14,R0              DECREMENT LENGTH FOR MVC             00106600
         EX    R14,MOVEDSN1        EXECUTE MOVE OF DSNAME               00106700
*        MVC   DYNDSN(0),0(R1)     EXECUTED INSTRUCTION COPY            00106800
         TM    DSNAME+14,X'80'     WAS MEMBER NAME SPECIFIED?           00106900
         BZ    MEMDONE             NO, SKIP IT                          00107000
         L     R1,DSNAME+8         LOAD A(MEMBER NAME)                  00107100
         LH    R14,DSNAME+12       LOAD LENGTH(DSNAME)                  00107200
         BCTR  R14,R0              DECREMENT LENGTH FOR MVC             00107300
         EX    R14,MOVEMEM1        EXECUTE MOVE OF DSNAME               00107400
*        MVC   DYNMBR(0),0(R1)     EXECUTED INSTRUCTION COPY            00107500
         OI    FLAG1,MBRREQ        SHOW MEMBER NAME GIVEN               00107600
MEMDONE  TM    VOL+6,X'80'         WAS VOLUME SPECIFIED?                00107700
         BO    VOLSET              YES, GO PROCESS VOLSER               00107800
         OI    DYNRTDDP,X'80'      ELSE, SET END OF LIST INDICATOR      00107900
         B     VOLDONE             AND SKIP VOLSER CHECKING             00108000
VOLSET   L     R1,VOL              LOAD A(VOLSER)                       00108100
         LH    R14,VOL+4           LOAD LENGTH(VOLSER)                  00108200
         BCTR  R14,R0              DECREMENT LENGTH FOR MVC             00108300
         EX    R14,MOVEVOL1        EXECUTE MOVE OF VOLSER               00108400
*        MVC   DYNVOL(0),0(R1)     EXECUTED INSTRUCTION COPY            00108500
         OI    FLAG1,VOLREQ        SHOW VOLSER GIVEN                    00108600
         DROP  R2                                                       00108700
VOLDONE  L     R15,CVTPTR          LOAD A(CVT)                          00108800
         L     R15,CVTPUTL-CVT(R15)   LOAD A(PUTLINE ROUTINE)           00108900
         ST    R15,ADDRPUTL        SAVE A(PUTLINE ROUTINE)              00109000
         LA    R1,DYNRBA           LOAD A(ALLOC PLIST)                  00109100
         SVC   99                  ISSUE DYNALLOC                       00109200
         LTR   R15,R15             WAS DYNALLOC SUCCESSFUL?             00109300
         MVC   MSGPART,=CL8'DYNALLOC'   SHOW ALLOC ERROR                00109400
         BNZ   MISCERR             NO, GO TELL USER                     00109500
         OI    FLAG1,ALLOCOK       SHOW DYNALLOC PERFORMED              00109600
         MVC   PDSDCB+DCBDDNAM-IHADCB(8),DYNRDDNM   MOVE DDNAME TO DCB  00109700
         MVC   DIRDCB+DCBDDNAM-IHADCB(8),DYNRDDNM   MOVE DDNAME TO DCB  00109800
         MVC   SEQDCB+DCBDDNAM-IHADCB(8),DYNRDDNM   MOVE DDNAME TO DCB  00109900
         TM    DYNRDSOR,DCBDSGPO   IS DSORG=PO?                         00110000
         BO    CHKMEM              YES, GO DO FURTHER CHECKING          00110100
         TM    DYNRDSOR,DCBDSGPS   ELSE, IS DSORG=PS?                   00110200
         BO    SEQREAD             YES, GO PROCESS IT                   00110300
         TM    DYNRDSOR,DCBDSGDA   ELSE, IS IT DSORG=DA?                00110400
         MVC   MSGPART,=CL8'DSORG' SHOW DSORG ERROR                     00110500
         BZ    MISCERR             NO, GO TELL USER (ONLY PO/PS/DA)     00110600
         B     SEQREAD             ELSE, GO READ DA                     00110700
CHKMEM   OI    FLAG1,DSORGPO       SHOW DSORG=PO                        00110800
         OPEN  (PDSDCB,INPUT)      OPEN DCB                             00110900
         TM    PDSDCB+DCBOFLGS-IHADCB,DCBOFOPN   WAS OPEN GOOD?         00111000
         MVC   MSGPART,=CL8'OPEN'  SHOW OPEN ERROR                      00111100
         BZ    MISCERR             NO, GO TELL USER                     00111200
         OI    FLAG1,OPENOK        SHOW OPEN PERFORMED                  00111300
         TM    FLAG1,MBRREQ        WAS A MEMBER REQUESTED?              00111400
         BZ    DIRLOOP             NO, SKIP BLDL, DO ENTIRE PDS         00111500
         MVC   BLDLDATA+PDS2NAME-PDS2,DYNMBR  MOVE MEMBER TO BLDL PLIST 00111600
         MVI   BLDLLIST+1,1        SET NUMBER OF MEMBERS                00111700
         MVI   BLDLLIST+3,BLDLLEN  SET SIZE OF MEMBER DATA              00111800
         BLDL  PDSDCB,BLDLLIST     LOCATE MEMBER IN PDS                 00111900
         LTR   R15,R15             WAS MEMBER FOUND?                    00112000
         MVC   MSGPART,=CL8'BLDL'  SHOW BLDL ERROR                      00112100
         BNZ   MISCERR             NO, GO TELL USER                     00112200
         OI    FLAG1,MBRFOUND      SHOW MEMBER FOUND                    00112300
         MVC   DIRMEMBR,DYNMBR     MOVE MEMBER NAME FOR FIND            00112400
         B     FINDMEMB            GO POSITION TO REQUESTED MEMBER      00112500
DIRLOOP  BAL   R14,READDIR         READ A DIRECTORY BLOCK/ENTRY         00112600
         CH    R15,=H'4'           WAS A MEMBER/ALIAS FOUND?            00112700
         BH    CLEANUP             YES, GO CLEAN UP                     00112800
FINDMEMB FIND  PDSDCB,DIRMEMBR,D   POSITION TO REQUESTED MEMBER         00112900
         LTR   R15,R15             WAS MEMBER FOUND?                    00113000
         MVC   MSGPART,=CL8'FIND'  SHOW FIND ERROR                      00113100
         BNZ   MISCERR             NO, GO TELL USER                     00113200
CHKRECFM TM    PDSDCB+DCBRECFM-IHADCB,DCBRECU   IS RECFM=U?             00113300
         BO    PDSDATA             YES, SKIP RECFM=V SETUP              00113400
         TM    PDSDCB+DCBRECFM-IHADCB,DCBRECF   IS RECFM=F?             00113500
         BO    PDSDATA             YES, SKIP RECFM=V SETUP              00113600
         OI    FLAG2,RECFMVAR      ELSE, SHOW RECFM=V                   00113700
PDSDATA  LA    R2,DATAAREA         LOAD A(DIR BLOCK DATA AREA)          00113800
PDSLOOP  READ  PDSDECB,SF,PDSDCB,(2),'S'   READ DATA BLOCK              00113900
         CHECK PDSDECB             CHECK THE READ                       00114000
         TM    FLAG2,RECFMVAR      IS RECFM=V?                          00114100
         LH    R1,PDSDCB+DCBBLKSI-IHADCB  ELSE, LOAD BLKSIZE(RECFM=F/U) 00114200
         L     R3,PDSDECB+DECIOBPT-DECB LOAD A(IOB) TO GET IOBCSW CNT   00114300
         SH    R1,IOBCSW+5-IOBSTDRD(R3) RESIDUAL COUNT-BLKSZ=DATA LEN   00114400
         B     PDSCRC              GO COMPUTE CRC                       00114500
PDSRECV  LH    R1,DATAAREA         LOAD DATA LENGTH FROM BDW            00114600
PDSCRC   L     R6,CRCDATA          LOAD CURRENT DATA CRC                00114700
         BAL   R14,COMPCRC         COMPUTE DATA CRC                     00114800
         ST    R6,CRCDATA          SAVE NEW DA                          00114900
         B     PDSLOOP             GO READ NEXT DATA BLOCK              00115000
PDSEOF   MVC   CRCTEMP,CRCDATA     SAVE CRCDATA FOR LATER               00115100
         XC    CRCDATA,FOXES       OR HIGH VALUES OVER CRC              00115200
         UNPK  UNPKAREA(9),CRCDATA(5)   UNPACK DATA CRC                 00115300
         TR    UNPKAREA(8),TRTABLE-240  MAKE DATA READABLE              00115400
         MVC   MSG1CRC,UNPKAREA         MOVE DATA TO MESSAGE AREA       00115500
         MVC   MSG1CRCK,MSG1KEYC        MOVE LITERAL TO MESSAGE AREA    00115600
         LA    R15,MSG1LEN         LOAD MESSAGE LENGTH                  00115700
   STH   R15,MSG1                  STORE MESSAGE LENGTH                 00115800
   MVC   MSG1MEMK,MSG1KEYM         MOVE LITERAL TO MESSAGE AREA         00115900
   MVC   MSG1MEMB,DIRMEMBR         MOVE MEMBER NAME TO MESSAGE AREA     00116000
   L     R15,ADDRPUTL              LOAD A(PUTLINE ROUTINE)              00116100
   PUTLINE OUTPUT=(MSG1,TERM,SINGLE,DATA),ENTRY=(15),                  X00116200
               MF=(E,IOPLAREA)     ISSUE MESSAGE                        00116300
         TM    FLAG1,MBRFOUND      WAS REQUEST FOR SINGLE MEMBER?       00116400
         BO    CLEANUP             YES, GO CLEAN UP                     00116500
         XC    CRCTOT,CRCTEMP      BUCKET TEMP CRC TO TOTAL CRC         00116600
         MVC   CRCDATA,FOXES       INITIALIZE DATA CRC                  00116700
         LA    R1,8                LOAD LENGTH(MEMBER NAME)             00116800
         LA    R2,DIRMEMBR         LOAD A(MEMBER NAME)                  00116900
         L     R6,CRCDIR           LOAD CURRENT DIRECTORY CRC           00117000
         BAL   R14,COMPCRC         COMPUTE DATA CRC                     00117100
         ST    R6,CRCDIR           SAVE NEW DIR CRC                     00117200
         B     DIRLOOP             GO TO PROCESS NEXT MEMBER            00117300
SEQREAD  OPEN  (SEQDCB,INPUT)      OPEN DCB                             00117400
         TM    SEQDCB+DCBOFLGS-IHADCB,DCBOFOPN   WAS OPEN GOOD?         00117500
         MVC   MSGPART,=CL8'OPEN'  SHOW OPEN ERROR                      00117600
         BZ    MISCERR             NO, GO TELL USER                     00117700
         OI    FLAG1,OPENOK        SHOW OPEN PERFORMED                  00117800
         TM    SEQDCB+DCBRECFM-IHADCB,DCBRECU   IS RECFM=U?             00117900
         BO    SEQDATA             YES, SKIP RECFM=V SETUP              00118000
         TM    SEQDCB+DCBRECFM-IHADCB,DCBRECF   IS RECFM=F?             00118100
         BO    SEQDATA             YES, SKIP RECFM=V SETUP              00118200
         OI    FLAG2,RECFMVAR      ELSE, SHOW RECFM=V                   00118300
SEQDATA  LA    R2,DATAAREA         LOAD A(INPUT AREA)                   00118400
SEQLOOP  READ  SEQDECB,SF,SEQDCB,(2),'S'   READ DATA BLOCK              00118500
         CHECK SEQDECB             CHECK THE READ                       00118600
         TM    FLAG2,RECFMVAR      IS RECFM=V?                          00118700
         BO    SEQRECV             YES, PROCESS RECFM=V                 00118800
         LH    R1,SEQDCB+DCBBLKSI-IHADCB ELSE, LOAD  BLKSIZE(RECFM=F/U) 00118900
         L     R3,SEQDECB+DECIOBPT-DECB  LOAD A(IOB) TO GET IOBCSW CNT  00119000
         SH    R1,IOBCSW+5-IOBSTDRD(R3)  RESIDUAL COUNT-BLKSZ=DATA LEN  00119100
         B     SEQCRC              GO COMPUTE CRC                       00119200
SEQRECV  LH    R1,DATAAREA  0(R2)  LOAD DATA LENGTH FROM BDW            00119300
SEQCRC   L     R6,CRCDATA          LOAD CURRENT DATA CRC                00119400
         BAL   R14,COMPCRC         COMPUTE DATA CRC                     00119500
         ST    R6,CRCDATA          SAVE NEW DATA CRC                    00119600
         B     SEQLOOP             GO READ NEXT DATA BLOCK              00119700
SEQEOF   CLOSE (SEQDCB)            CLOSE DCB                            00119800
         NI    FLAG1,255-OPENOK    SHOW DCB NOT OPEN                    00119900
         XC    CRCDATA,FOXES       OR HIGH VALUES OVER DATA CRC         00120000
         UNPK  UNPKAREA(9),CRCDATA(5)    UNPACK DATA CRC                00120100
         TR    UNPKAREA(8),TRTABLE-240   MAKE DATA READABLE             00120200
         MVC   MSG1CRC,UNPKAREA    MOVE DATA TO MESSAGE AREA            00120300
         MVC   MSG1CRCK,MSG1KEYC   MOVE LITERAL TO MESSAGE AREA         00120400
         MVC   MSG1DSNK,MSG1KEYG   MOVE LITERAL TO MESSAGE AREA         00120500
         MVC   MSG1DSN3,DYNDSN     MOVE DSNAME TO MESSAGE AREA          00120600
         LA    R15,MSG1LEN         LOAD MESSAGE LENGTH                  00120700
         STH   R15,MSG1            STORE MESSAGE LENGTH                 00120800
         L     R15,ADDRPUTL        LOAD A(PUTLINE ROUTINE)              00120900
         PUTLINE OUTPUT=(MSG1,TERM,SINGLE,DATA),ENTRY=(15),            X00121000
               MF=(E,IOPLAREA)     ISSUE MESSAGE                        00121100
         B     CLEANUP             GO CLEAN UP                          00121200
COMPCRC  LR    R3,R2               COPY A(DATAAREA BLOCK) FOR BXLE      00121300
         LA    R4,1                LOAD INCREMENT FOR BXLE              00121400
         LA    R5,0(R2,R1)         LOAD A(LAST BYTE+1) AS COMPARAND     00121500
         BCTR  R5,R0               LOAD A(REAL LAST BYTE) FOR BXLE      00121600
         L     R8,=A(CRCTABLE)     LOAD A(CRC TABLE)                    00121700
         L     R9,=X'000000FF'     LOAD MASK FOR LATER AND'ING          00121800
BYTELOOP IC    R7,0(,R3)           LOAD DATAAREA BYTE                   00121900
         XR    R7,R6               OR PREV CRC WITH DATAAREA BYTE       00122000
         NR    R7,R9               ISOLATE LOW ORDER BYTE               00122100
         SLL   R7,2                MULTIPLY BY FOUR FOR TABLE INDEX     00122200
         SRL   R6,8                SHIFT LOW ORDER BYTE OF PREV CRC     00122300
         X     R6,0(R7,R8)         UPDATE RUNNING CRC W/TABLE ENTRY     00122400
         BXLE  R3,R4,BYTELOOP      LOOP UNTIL END OF DATAAREA BLOCK     00122500
         BR    R14                 RETURN TO CALLER                     00122600
CLEANUP  CLC   CRCDIR,FOXES        IS THERE ANY DIR CRC TO DISPLAY?     00122700
         BE    CKCRCTOT            NO, SKIP DISPLAY                     00122800
         UNPK  UNPKAREA(9),CRCDIR(5)   UNPACK DIR CRC                   00122900
         TR    UNPKAREA(8),TRTABLE-240 MAKE DATA READABLE               00123000
         MVC   MSG1CRC,UNPKAREA    MOVE DATA TO MESSAGE AREA            00123100
         MVC   MSG1CRCK,MSG1KEYC   MOVE LITERAL TO MESSAGE AREA         00123200
         LA    R15,MSG1LEN         LOAD MESSAGE LENGTH                  00123300
         STH   R15,MSG1            STORE MESSAGE LENGTH                 00123400
         MVC   MSG1DIRK,MSG1KEYD   MOVE LITERAL TO MSG AREA             00123500
         MVC   MSG1DSN1,DYNDSN     MOVE DSNAME TO MESSAGE AREA          00123600
         L     R15,ADDRPUTL        LOAD A(PUTLINE ROUTINE)              00123700
         PUTLINE OUTPUT=(MSG1,TERM,SINGLE,DATA),ENTRY=(15),            X00123800
               MF=(E,IOPLAREA)     ISSUE MESSAGE                        00123900
CKCRCTOT CLC   CRCTOT,FOXES        IS THERE A TOTAL CRC TO DISPLAY?     00124000
         BE    CKOPEN              NO, SKIP DISPLAY                     00124100
         MVC   CRCTEMP,CRCTOT      SAVE TOTAL CRC FOR LATER             00124200
         XC    CRCTOT,FOXES        ELSE, OR HIGH VALUES ON TOT CRC      00124300
         UNPK  UNPKAREA(9),CRCTOT(5)   UNPACK TOTAL CRC                 00124400
         TR    UNPKAREA(8),TRTABLE-240 MAKE DATA READABLE               00124500
         MVC   MSG1CRC,UNPKAREA    MOVE DATA TO MESSAGE AREA            00124600
         MVC   MSG1CRCK,MSG1KEYC   MOVE LITERAL TO MESSAGE AREA         00124700
         LA    R15,MSG1LEN         LOAD MESSAGE LENGTH                  00124800
         STH   R15,MSG1            STORE MESSAGE LENGTH                 00124900
         MVC   MSG1MEMS,MSG1KEYT   MOVE LITERAL TO MSG AREA             00125000
         MVC   MSG1DSN2,DYNDSN     MOVE DSNAME TO MESSAGE AREA          00125100
         L     R15,ADDRPUTL        LOAD A(PUTLINE ROUTINE)              00125200
         PUTLINE OUTPUT=(MSG1,TERM,SINGLE,DATA),ENTRY=(15),            X00125300
               MF=(E,IOPLAREA)     ISSUE MESSAGE                        00125400
         XC    CRCGRTOT,CRCDIR     OR DIR CRC ON GRAND TOT CRC          00125500
         XC    CRCGRTOT,CRCTEMP    OR DATA TOTAL CRC ON GR TOT CRC      00125600
         XC    CRCGRTOT,FOXES      OR HIGH VALUES ON GRAND TOT CRC      00125700
         UNPK  UNPKAREA(9),CRCGRTOT(5) UNPACK GRAND TOTAL CRC           00125800
         TR    UNPKAREA(8),TRTABLE-240 MAKE DATA READABLE               00125900
         MVC   MSG1CRC,UNPKAREA    MOVE DATA TO MESSAGE AREA            00126000
         MVC   MSG1CRCK,MSG1KEYC   MOVE LITERAL TO MESSAGE AREA         00126100
         LA    R15,MSG1LEN         LOAD MESSAGE LENGTH                  00126200
         STH   R15,MSG1            STORE MESSAGE LENGTH                 00126300
         MVC   MSG1DSNK,MSG1KEYG   MOVE LITERAL TO MSG AREA             00126400
         MVC   MSG1DSN3,DYNDSN     MOVE DSNAME TO MESSAGE AREA          00126500
         L     R15,ADDRPUTL        LOAD A(PUTLINE ROUTINE)              00126600
         PUTLINE OUTPUT=(MSG1,TERM,SINGLE,DATA),ENTRY=(15),            X00126700
               MF=(E,IOPLAREA)     ISSUE MESSAGE                        00126800
CKOPEN   TM    FLAG1,OPENOK        WAS OPEN DONE?                       00126900
         BZ    SKIPCLOS            NO, SKIP CLOSE                       00127000
         CLOSE (PDSDCB)            ELSE, CLOSE DCB                      00127100
SKIPCLOS TM    FLAG1,ALLOCOK       WAS DYNALLOC DONE?                   00127200
         BZ    SKIPDYNF            NO, SKIP DYNALLOC                    00127300
         MVC   DYNFDDN,DYNRDDNM    SET DDNAME                           00127400
         LA    R1,DYNRBF           LOAD A(DEALLOC PLIST)                00127500
         SVC   99                  ISSUE DYNALLOC                       00127600
         LTR   R15,R15             WAS DYNALLOC SUCCESSFUL?             00127700
         BZ    SKIPDYNF            YES, SKIP MESSAGE                    00127800
         MVC   MSGPART,=CL8'DYN FREE'  SHOW DELALLOC ERROR              00127900
         L     R15,ADDRPUTL        LOAD A(PUTLINE ROUTINE)              00128000
         PUTLINE OUTPUT=(MSGPARS,TERM,SINGLE,DATA),ENTRY=(15),         X00128100
               MF=(E,IOPLAREA)     ISSUE MESSAGE                        00128200
SKIPDYNF TM    FLAG1,PARSEOK       WAS PARSE DONE?                      00128300
         BZ    RETURN              NO, SKIP RELEASE                     00128400
         IKJRLSA PDLADDR           RELEASE ANSWER AREA                  00128500
RETURN   LR    R2,R15              SAVE RETURN CODE                     00128600
         LR    R1,R13              LOAD R1 W/A(SAVEAREA)                00128700
         L     R13,4(,R13)         LOAD R13 W/ADDR OF CALLER'S S/A      00128800
*        STORAGE RELEASE,ADDR=(1),LENGTH=WORKLEN FREE STORAGE       JLM 00128900
         L     R0,WLEN                                              JLM 00129000
         FREEMAIN R,A=(1),LV=(0)                                    JLM 00129100
         LR    R15,R2              RESTORE RETURN CODE                  00129200
         RETURN (14,12),RC=(15)    RETURN TO CALLER                     00129300
WLEN     DC    A(WORKLEN)                                           JLM 00129400
MISCERR  L     R15,ADDRPUTL        LOAD A(PUTLINE ROUTINE)              00129500
         PUTLINE OUTPUT=(MSGPARS,TERM,SINGLE,DATA),ENTRY=(15),         X00129600
               MF=(E,IOPLAREA)     ISSUE ERROR MESSAGE                  00129700
         B     CLEANUP             GO CLEAN UP                          00129800
READDIR  STM   R14,R3,DIRSAVE      SAVE CURRENT REGISTERS               00129900
         LM    R14,R3,DIRLOAD      RELOAD PREVIOUS REGISTERS            00130000
         TM    FLAG1,PDSDIROP      WAS DIRECTORY ALREADY OPENED?        00130100
         BO    CALCSIZE            YES, SKIP OPEN/READ                  00130200
         OPEN  (DIRDCB,INPUT)      OPEN DIRECTORY                       00130300
         TM    DIRDCB+DCBOFLGS-IHADCB,DCBOFOPN WAS OPEN GOOD?           00130400
         BZ    DIROPBAD            NO, GO SET RETURN CODE               00130500
         OI    FLAG1,PDSDIROP      ELSE, SHOW OPEN PERFORMED            00130600
GETDIR   XC    DIRBLOCK,DIRBLOCK   CLEAR DIRECTORY BLOCK IN             00130700
         GET   DIRDCB,DIRBLOCK     READ A DIRECTORY BLOCK               00130800
         LA    R15,2               ACCOUNT FOR DIR BLOCK LEN BYTES      00130900
         LA    R1,DIRBLOCK+2       LOAD A(DIR DATA)                     00131000
         B     CKDIREOF            GO CHECK DIRECTORY EOF               00131100
         USING PDS2,R1                                                  00131200
CALCSIZE MVC   DIRBLKSZ+3(1),PDS2INDC  MOVE # HALFWORDS TO WORK AREA    00131300
         NI    DIRBLKSZ+3,PDS2LUSR ISOLATE # OF USERDATA HALFWORDS      00131400
         L     R2,DIRBLKSZ         LOAD NUMBER OF HALFWORDS             00131500
         LA    R2,12(R2,R2)        LOAD LENGTH(DIR ENTRY)  X*2+12       00131600
         AR    R15,R2              POINT TO END OF THIS DIR ENTRY       00131700
         CH    R15,DIRBLOCK        ARE WE AT END OF DIR BLOCK?          00131800
         BNL   GETDIR              YES, GO GET NEXT DIR BLOCK           00131900
         AR    R1,R2               ELSE, POINT TO NEXT DIR ENTRY        00132000
CKDIREOF CLC   PDS2NAME,FOXES      ARE WE AT LOGICAL EOF?               00132100
         BE    DIREOF              YES, GO CLEAN UP                     00132200
         MVC   DIRMEMBR,PDS2NAME   ELSE, SAVE MEMBER NAME FOR LATER     00132300
         TM    PDS2INDC,PDS2ALIS   IS THIS AN ALIAS ENTRY?              00132400
         BZ    MAINMBR             NO, GO SET RC=0 (MAIN MEMBER)        00132500
         LA    R0,4                ELSE, SET RC=4 (ALIAS MEMBER)        00132600
         B     DIREXIT             GO TO EXIT                           00132700
MAINMBR  LA    R0,0                SET RC=0 (MAIN MEMBER)               00132800
         B     DIREXIT             GO TO EXIT                           00132900
DIROPBAD LA    R0,12               SET RC=12 (OPEN ERROR)               00133000
         B     DIREXIT             GO TO EXIT                           00133100
DIREOF   NI    FLAG1,255-PDSDIROP  CLEAR DIR OPEN FLAG                  00133200
         CLOSE (DIRDCB)            CLOSE DCB                            00133300
         XC    DIRMEMBR,DIRMEMBR   CLEAR MEMBER NAME                    00133400
         XC    CRCDIR,FOXES        OR HIGH VALUES OVER DIR CRC          00133500
         LA    R0,8                SET RC=8 (DIRECTORY EOF)             00133600
DIREXIT  ST    R0,DIRSAVE+4        SAVE RETURN CODE                     00133700
         STM   R14,R3,DIRLOAD      SAVE CURRENT REGISTERS               00133800
         LM    R14,R3,DIRSAVE          RELOAD PREVIOUS REGISTERS        00133900
         BR    R14                     RETURN TO CALLER                 00134000
         DROP  R1                                                       00134100
MSGPARS  DC    AL2(MSGPARSL,0)         OUTPUT DESCRIPTOR -----------    00134200
         DC    C'*** Error encountered in '                             00134300
MSGPART  DC    CL8' '                                                   00134400
MSGPARSL EQU   *-MSGPARS               MESSAGE LENGTH --------------    00134500
FOXES    DC    8X'FF'                  DIRECTORY EOF FLAG/CRC INIT VAL  00134600
MSG1KEYM DC    C'for member '          MESSAGE FIELD                    00134700
MSG1KEYC DC    C'CRC is '              MESSAGE FIELD                    00134800
MSG1KEYD DC    C'for directory of '    MESSAGE FIELD                    00134900
MSG1KEYT DC    C'for members of '      MESSAGE FIELD                    00135000
MSG1KEYG DC    C'for dataset '         MESSAGE FIELD                    00135100
TRTABLE  DC    C'0123456789ABCDEF'     TRANSLATE TABLE                  00135200
PUTBLK   PUTLINE MF=L                  IOPB FOR PARSE                   00135300
MOVEDSN1 MVC   DYNDSN(0),0(R1)         EXECUTED MVC OF DSNAME           00135400
MOVEMEM1 MVC   DYNMBR(0),0(R1)         EXECUTED MVC OF MEMBER NAME      00135500
MOVEVOL1 MVC   DYNVOL(0),0(R1)         EXECUTED MVC OF VOLSER           00135600
DYNRBF   DC    A(DYNRBFFL+X'80000000') POINTER TO REQUEST BLOCK         00135700
DYNRBFFL DC    AL1(20,2,0,0)           LENGTH, DEALLOC VERB, FLAGS1     00135800
DYNFERR  DC    AL2(0)                  ERROR CODE                       00135900
DYNFINFO DC    AL2(0)                  INFORMATION CODE                 00136000
DYNFTUO  DC    A(DYNFTU01),AL4(0,0)    TEXT UNIT POINTER, RSVD, FLAGS2  00136100
DYNFTU01 DC    A(DYNFDDNM+X'80000000') LAST TEXT UNIT POINTER           00136200
DYNFDDNM DC    AL2(DALDDNAM,1,8)       DDNAME KEY, NUM, PARMLEN         00136300
DYNFDDN  DC    CL8' '                  DDNAME FIELD                     00136400
DYNRBA   DC    A(DYNRBAFL+X'80000000') POINTER TO REQUEST BLOCK         00136500
DYNRBAFL DC    AL1(20,1,0,0)           LENGTH, ALLOC VERB, FLAGS1       00136600
DYNAERR  DC    AL2(0)                  ERROR CODE                       00136700
DYNAINFO DC    AL2(0)                  INFORMATION CODE                 00136800
DYNATUO  DC    A(DYNATU01),AL4(0,0)    TEXT UNIT POINTER, RSVD, FLAGS2  00136900
DYNATU01 DC    A(DYNDSNAM)             DSNAME TEXT UNIT POINTER         00137000
         DC    A(DYNSTATS)             STATUS TEXT UNIT POINTER         00137100
         DC    A(DYNRETOR)             RET DSORG TEXT UNIT POINTER      00137200
DYNRTDDP DC    A(DYNRETDD)             RET DDNAME TEXT UNIT POINTER     00137300
         DC    A(DYNVLSER)             VOLSER TEXT UNIT POINTER         00137400
         DC    A(DYNUNITT+X'80000000') UNIT   TEXT UNIT POINTER         00137500
DYNDSNAM DC    AL2(DALDSNAM,1,44)      DSNAME KEY, NUM, PARMLEN         00137600
DYNDSN   DC    CL44' '                 DSNAME FIELD                     00137700
DYNMEMBR DC    AL2(DALMEMBR,1,8)       MEMBER/GDG KEY, NUM, PARMLEN     00137800
DYNMBR   DC    CL8' '                  MEMBER NAME/GDG LEVEL FIELD      00137900
DYNSTATS DC    AL2(DALSTATS,1,1)       DATASET STATUS KEY, NUM, PARMLEN 00138000
DYNSTAT  DC    XL1'08'                 CONSTANT FOR DISP=SHR            00138100
DYNVLSER DC    AL2(DALVLSER,1,6)       VOLSER KEY, NUM, PARMLEN         00138200
DYNVOL   DC    CL6' '                  VOLUME SERIAL FIELD              00138300
DYNUNITT DC    AL2(DALUNIT,1,8)        UNIT TYPE KEY, NUM, PARMLEN      00138400
DYNUNIT  DC    CL8'SYSDA'              UNIT TYPE FIELD                  00138500
DYNRETDD DC    AL2(DALRTDDN,1,8)       RETURN DDNAME, NUM, PARMLEN      00138600
DYNRDDNM DC    CL8' '                  RETURNED DDNAME                  00138700
DYNRETOR DC    AL2(DALRTORG,1,2)       RETURN DSORG, NUM, PARMLEN       00138800
DYNRDSOR DC    XL2'0000'               RETURNED DSORG                   00138900
SEQDCB   DCB   DDNAME=XXXXXXXX,DSORG=PS,MACRF=R,EODAD=SEQEOF            00139000
PDSDCB   DCB   DDNAME=XXXXXXXX,DSORG=PO,MACRF=R,EODAD=PDSEOF            00139100
DIRDCB   DCB   DDNAME=XXXXXXXX,DSORG=PS,MACRF=GM,EODAD=DIREOF,         X00139200
               LRECL=256,BLKSIZE=256,RECFM=F                            00139300
CRCPCL   IKJPARM DSECT=IKJPARMD                                         00139400
DSNAME   IKJPOSIT DSNAME,USID,UPPERCASE,PROMPT='Dataset name'           00139500
VOLSERKW IKJKEYWD                                                       00139600
         IKJNAME  'VOLUME',SUBFLD=VOLSF                                 00139700
VOLSF    IKJSUBF                                                        00139800
VOL      IKJIDENT 'VOLSER',FIRST=ALPHANUM,OTHER=ALPHANUM,MAXLNTH=6,    X00139900
               PROMPT='Volume serial on which dataset resides'          00140000
         IKJENDP                                                        00140100
         CVT   DSECT=YES,LIST=NO       CVT                              00140200
CPPL     IKJCPPL                       CPPL                             00140300
CPPLLEN  EQU   *-CPPL                  CPPL LENGTH                      00140400
PPL      IKJPPL                        PPL                              00140500
PPLLEN   EQU   *-PPL                   PPL LENGTH                       00140600
IOPPL    IKJIOPL                       IOPL FOR PUTLINE                 00140700
IOPLLEN  EQU   *-IOPL                  IOPL LENGTH                      00140800
DCBMAP   DCBD  DSORG=(PS,PO),DEVD=DA   DCB PLIST                        00140900
         IHAPDS DSECT=YES,PDSBLDL=NO   PDS DIRECTORY ENTRY MAPPING      00141000
         IHADECB DSECT=YES             DATA EVENT CONTROL BLOCK         00141100
         IEZIOB DSECT=YES              INPUT/OUTPUT BLOCK               00141200
         IEFZB4D2                      SVC 99 TEXT UNIT KEYS            00141300
WORKAREA DSECT                         WORKAREA                         00141400
SAVEAREA DS    18F                     SHOULD BE FIRST IN WORKAREA      00141500
DIRSAVE  DS    6F                      REGISTER SAVE AREA -----------   00141600
DIRLOAD  DS    6F                      REGISTER SAVE AREA               00141700
DIRSAVEL EQU   *-DIRSAVE               SAVE AREA FIELD LENGTH -------   00141800
DIRBLKSZ DS    F                       DIRECTORY BLOCK SIZE AREA ----   00141900
CRCTEMP  DS    F                       TEMP STORAGE FOR CRC             00142000
CRCDATA  DS    F                       DERIVED CHECKSUM FOR DATA        00142100
CRCDIR   DS    F                       DERIVED CHECKSUM FOR DIRECTORY   00142200
CRCTOT   DS    F                       DERIVED CHECKSUM TOTAL MEMBERS   00142300
CRCGRTOT DS    F                       DERIVED CHECKSUM GRAND TOTAL     00142400
ECB      DS    A                       ECB                              00142500
ADDRPUTL DS    A                       A(PUTLINE ROUTINE)               00142600
PDLADDR  DS    A                       A(PDL)                           00142700
PPLAREA  DS    (PPLLEN)X               PPL WORKAREA                     00142800
IOPLAREA DS    (IOPLLEN)X              IOPL WORKAREA                    00142900
UNPKAREA DS    D,X                     AREA FOR UNPACKING/SLACK BYTE    00143000
BLDLLIST DS    2H                      BLDL PLIST HEADER -----          00143100
BLDLDATA DS    XL60                    BLDL PLIST DATA                  00143200
BLDLLEN  EQU   *-BLDLDATA              BLDL PLIST LENGTH------          00143300
FLAG1    DS    XL2                     INDICATOR FLAG1 -------          00143400
PDSDIROP EQU   X'80'                   PDS DIR OPEN PERFORMED           00143500
PARSEOK  EQU   X'40'                   PARSE PERFORMED                  00143600
MBRREQ   EQU   X'20'                   MEMBER NAME GIVEN                00143700
VOLREQ   EQU   X'10'                   VOLSER GIVEN                     00143800
ALLOCOK  EQU   X'08'                   DYNALLOC PERFORMED               00143900
OPENOK   EQU   X'04'                   OPEN PERFORMED                   00144000
MBRFOUND EQU   X'02'                   MEMBER FOUND                     00144100
DSORGPO  EQU   X'01'                   DSORG=PO (VS. PS/DA) --          00144200
FLAG2    DS    X                       INDICATOR FLAG2 -------          00144300
RECFMVAR EQU   X'80'                   DATASET RECFM=V                  00144400
CLEARLEN EQU   *-DIRBLKSZ              BINARY FIELDS LENGTH ---------   00144500
DIRBLOCK DS    0F,XL256                DIRECTORY BLOCK AREA             00144600
DSN      DS    CL44                    DSNAME -----------------------   00144700
MEMBER   DS    CL8                     MEMBER                           00144800
DIRMEMBR DS    CL8                     DIRECTORY MEMBER NAME            00144900
VOLUME   DS    CL6                     VOLSER                           00145000
MSG1     DS    0F,2AL2                 OUTPUT DESCRIPTOR -----          00145100
MSG1CRCK DS    CL(L'MSG1KEYC)          'CRC is '                        00145200
MSG1CRC  DS    CL8                     cccccccc                         00145300
         DS    CL1                                                      00145400
MSG1MEMK DS    CL(L'MSG1KEYM)          'for member '                    00145500
MSG1MEMB DS    CL8                     mmmmmmmm                         00145600
         DS    CL(80-(*-MSG1CRCK))     FILLER                           00145700
         ORG   MSG1MEMK                                                 00145800
MSG1DIRK DS    CL(L'MSG1KEYD)          'for directory of '              00145900
MSG1DSN1 DS    CL44                    dsn                              00146000
         ORG   MSG1MEMK                                                 00146100
MSG1MEMS DS    CL(L'MSG1KEYT)          'for members of '                00146200
MSG1DSN2 DS    CL44                    dsn                              00146300
         ORG   MSG1MEMK                                                 00146400
MSG1DSNK DS    CL(L'MSG1KEYG)          'for dataset '                   00146500
MSG1DSN3 DS    CL44                    dsn                              00146600
MSG1LEN2 EQU   *-MSG1MEMK                                               00146700
         ORG   ,                                                        00146800
MSG1LEN  EQU   *-MSG1                  MESSAGE LENGTH --------          00146900
CHARLEN  EQU   *-DSN                   CHARACTER FIELDS LENGTH ------   00147000
DATAAREA DS    0F,CL32768              DATA AREA FOR BSAM READ          00147100
WORKLEN  EQU   *-WORKAREA              WORKAREA LENGTH                  00147200
CRCTABLE CSECT                                                          00147300
         DC    X'0000000077073096EE0E612C990951BA'  00-03               00147400
         DC    X'076DC419706AF48FE963A5359E6495A3'  04-07               00147500
         DC    X'0EDB883279DCB8A4E0D5E91E97D2D988'  08-0B               00147600
         DC    X'09B64C2B7EB17CBDE7B82D0790BF1D91'  0C-0F               00147700
         DC    X'1DB710646AB020F2F3B9714884BE41DE'  10-13               00147800
         DC    X'1ADAD47D6DDDE4EBF4D4B55183D385C7'  14-17               00147900
         DC    X'136C9856646BA8C0FD62F97A8A65C9EC'  18-1B               00148000
         DC    X'14015C4F63066CD9FA0F3D638D080DF5'  1C-1F               00148100
         DC    X'3B6E20C84C69105ED56041E4A2677172'  20-23               00148200
         DC    X'3C03E4D14B04D447D20D85FDA50AB56B'  24-27               00148300
         DC    X'35B5A8FA42B2986CDBBBC9D6ACBCF940'  28-2B               00148400
         DC    X'32D86CE345DF5C75DCD60DCFABD13D59'  2C-2F               00148500
         DC    X'26D930AC51DE003AC8D75180BFD06116'  30-33               00148600
         DC    X'21B4F4B556B3C423CFBA9599B8BDA50F'  34-37               00148700
         DC    X'2802B89E5F058808C60CD9B2B10BE924'  38-3B               00148800
         DC    X'2F6F7C8758684C11C1611DABB6662D3D'  3C-3F               00148900
         DC    X'76DC419001DB710698D220BCEFD5102A'  40-43               00149000
         DC    X'71B1858906B6B51F9FBFE4A5E8B8D433'  44-47               00149100
         DC    X'7807C9A20F00F9349609A88EE10E9818'  48-4B               00149200
         DC    X'7F6A0DBB086D3D2D91646C97E6635C01'  4C-4F               00149300
         DC    X'6B6B51F41C6C6162856530D8F262004E'  50-53               00149400
         DC    X'6C0695ED1B01A57B8208F4C1F50FC457'  54-57               00149500
         DC    X'65B0D9C612B7E9508BBEB8EAFCB9887C'  58-5B               00149600
         DC    X'62DD1DDF15DA2D498CD37CF3FBD44C65'  5C-5F               00149700
         DC    X'4DB261583AB551CEA3BC0074D4BB30E2'  60-63               00149800
         DC    X'4ADFA5413DD895D7A4D1C46DD3D6F4FB'  64-67               00149900
         DC    X'4369E96A346ED9FCAD678846DA60B8D0'  68-6B               00150000
         DC    X'44042D7333031DE5AA0A4C5FDD0D7CC9'  6C-6F               00150100
         DC    X'5005713C270241AABE0B1010C90C2086'  70-73               00150200
         DC    X'5768B525206F85B3B966D409CE61E49F'  74-77               00150300
         DC    X'5EDEF90E29D9C998B0D09822C7D7A8B4'  78-7B               00150400
         DC    X'59B33D172EB40D81B7BD5C3BC0BA6CAD'  7C-7F               00150500
         DC    X'EDB883209ABFB3B603B6E20C74B1D29A'  80-83               00150600
         DC    X'EAD547399DD277AF04DB261573DC1683'  84-87               00150700
         DC    X'E3630B1294643B840D6D6A3E7A6A5AA8'  88-8B               00150800
         DC    X'E40ECF0B9309FF9D0A00AE277D079EB1'  8C-8F               00150900
         DC    X'F00F93448708A3D21E01F2686906C2FE'  90-93               00151000
         DC    X'F762575D806567CB196C36716E6B06E7'  94-97               00151100
         DC    X'FED41B7689D32BE010DA7A5A67DD4ACC'  98-9B               00151200
         DC    X'F9B9DF6F8EBEEFF917B7BE4360B08ED5'  9C-9F               00151300
         DC    X'D6D6A3E8A1D1937E38D8C2C44FDFF252'  A0-A3               00151400
         DC    X'D1BB67F1A6BC57673FB506DD48B2364B'  A4-A7               00151500
         DC    X'D80D2BDAAF0A1B4C36034AF641047A60'  A8-AB               00151600
         DC    X'DF60EFC3A867DF55316E8EEF4669BE79'  AC-AF               00151700
         DC    X'CB61B38CBC66831A256FD2A05268E236'  B0-B3               00151800
         DC    X'CC0C7795BB0B4703220216B95505262F'  B4-B7               00151900
         DC    X'C5BA3BBEB2BD0B282BB45A925CB36A04'  B8-BB               00152000
         DC    X'C2D7FFA7B5D0CF312CD99E8B5BDEAE1D'  BC-BF               00152100
         DC    X'9B64C2B0EC63F226756AA39C026D930A'  C0-C3               00152200
         DC    X'9C0906A9EB0E363F7207678505005713'  C4-C7               00152300
         DC    X'95BF4A82E2B87A147BB12BAE0CB61B38'  C8-CB               00152400
         DC    X'92D28E9BE5D5BE0D7CDCEFB70BDBDF21'  CC-CF               00152500
         DC    X'86D3D2D4F1D4E24268DDB3F81FDA836E'  D0-D3               00152600
         DC    X'81BE16CDF6B9265B6FB077E118B74777'  D4-D7               00152700
         DC    X'88085AE6FF0F6A7066063BCA11010B5C'  D8-DB               00152800
         DC    X'8F659EFFF862AE69616BFFD3166CCF45'  DC-DF               00152900
         DC    X'A00AE278D70DD2EE4E0483543903B3C2'  E0-E3               00153000
         DC    X'A7672661D06016F74969474D3E6E77DB'  E4-E7               00153100
         DC    X'AED16A4AD9D65ADC40DF0B6637D83BF0'  E8-EB               00153200
         DC    X'A9BCAE53DEBB9EC547B2CF7F30B5FFE9'  EC-EF               00153300
         DC    X'BDBDF21CCABAC28A53B3933024B4A3A6'  F0-F3               00153400
         DC    X'BAD03605CDD7069354DE572923D967BF'  F4-F7               00153500
         DC    X'B3667A2EC4614AB85D681B022A6F2B94'  F8-FB               00153600
         DC    X'B40BBE37C30C8EA15A05DF1B2D02EF8D'  FC-FF               00153700
         END                                                            00153800
/*                                                                      00153900
//*----------------------------------------------------------- ASM      00154000
/*                                                                      00154100
//LKED.SYSIN DD *                                                       00154200
  NAME CRC32(R)                                                         00154300
//*----------------------------------------------------------- LKED     00154400
//                                                                      00154500

